# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import gtk
import Conf, GConf

class Group :
	GROUP = None
	WINDOW = None

	def __init__ (self) :
		self.GROUP = gtk.AccelGroup()

	def __del__ (self) :
		if self.WINDOW : self.WINDOW.remove_accel_group(self.GROUP)

	def lock (self) : self.GROUP.lock()
	def unlock (self) : self.GROUP.unlock()

	def add_to_window (self, window) :
		if not isinstance(window, gtk.Window) :
			raise TypeError, _("window must be the instance of gtk.Window.")

		self.WINDOW = window
		self.WINDOW.add_accel_group(self.GROUP)

	def remove_from_window (self, window) :
		self.WINDOW.remove_accel_group(self.GROUP)

	def add_key (self, accel_key, accel_mods, callback) :
		if not gtk.accelerator_valid(accel_key, accel_mods) :
			return False

		self.GROUP.connect_group(accel_key, accel_mods, \
			gtk.ACCEL_VISIBLE, callback)

		return True

	def remove_key (self, accel_key, accel_mods) :
		if not gtk.accelerator_valid(accel_key, accel_mods) :
			return False

		return self.GROUP.disconnect_key(accel_key, accel_mods)

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "Accel.py"


