# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import time
import Window, func

class Note :
	NOTE = None
	STATE = None

	LIST = list()
	DICT = dict()
	DICT_R = dict()

	def __init__ (self, notesItem, **kwargs) :
		self.NOTE = notesItem

		if not kwargs.has_key("state") :
			raise RuntimeError, "state must be given."
		else :
			self.STATE = kwargs["state"]

		self.initiate()

	def initiate (self) :
		self.DICT = dict()
		self.DICT_R = dict()
		for __uid in self.NOTE.get_list() :
			self.add(__uid, "not sort now!")

		self.__sort_by_time_to_alarm()

	def __sort_by_time_to_alarm (self) :
		__l = self.DICT.keys()
		__l.sort()

		self.LIST = list()
		for i in __l : self.LIST.append(self.DICT[i])

	def add (self, uid, not_sort=False) :
		if self.DICT_R.has_key(uid) : return

		__t = self.NOTE.get_value(uid, "asDict")["time_to_alarm"]

		if __t > 0 and __t > time.time() :
			self.DICT[__t] = uid
			self.DICT_R[uid] = __t
			if not_sort : self.__sort_by_time_to_alarm()

	def change (self, uid) :
		if not self.DICT_R.has_key(uid) : return

		__t = self.DICT_R[uid]
		del(self.DICT[__t])

		__t = self.NOTE.get_value(uid, "asDict")["time_to_alarm"]
		self.DICT[__t] = uid
		self.DICT_R[uid] = __t

		self.__sort_by_time_to_alarm()

	def reset (self, uid) :
		if not uid : return

		self.DICT_R[uid] = self.NOTE.get_value(uid, "asDict")["time_to_alarm"]
		self.__sort_by_time_to_alarm()

	def remove (self, uid) :
		if self.DICT.has_key(uid) :
			__t = self.DICT_R[uid]
			del(self.DICT[__t])
			del(self.DICT_R[uid])

		__i = self.LIST.index(uid)
		del(self.LIST[__i])

	def run (self) :
		for i in self.LIST :
			if time.time() > self.DICT_R[i] :
				__title = self.NOTE.get_value(i, "asDict")["title"]
				Window.Alarm(func.unquote_filename(__title), i, state=self.STATE)
				self.remove(i)
			else :
				continue

		self.initiate()

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "Alarm.py"


