# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import os, shutil
import gnome, gnome.vfs
import Conf, Conf__

class Core :

	DIRECTORY = None
	PAGENAME = None

	def __init__ (self, pagename) :

		self.PAGENAME = pagename
		self.DIRECTORY = os.path.join( \
			Conf.DIR_NOTE_ATTACHMENT, self.PAGENAME)

		self.create_directory()

	def create_directory (self) :
		if not os.path.isdir(self.DIRECTORY) :
			os.makedirs(self.DIRECTORY)

	def get_list (self) :
		__l = os.listdir(self.DIRECTORY)

		__dd = dict()
		for i in __l :
			if not os.path.isfile(os.path.join(self.DIRECTORY, i)) : continue
			__dd[int(self.get_info(i).ctime)] = i

		# sort by ctime reversly.
		__k = __dd.keys()
		__k.sort()
		__k.reverse()

		__list = list()
		for i in __k :
			__list.append(__dd[i])

		return __list

	##############################################
	# FILE METHOD
	def get_info (self, filename) :
		"""
		@return : gnome.vfs.FileInfo
		"""
		__filepath = os.path.join(self.DIRECTORY, filename)
		return gnome.vfs.get_file_info(__filepath)

	def get_full_path (self, filename) :
		return os.path.join(self.DIRECTORY, filename)

	def is_exist (self, filename) :
		__filepath = os.path.join(self.DIRECTORY, filename)
		if not os.path.isfile(__filepath) :
			return False
		else :
			return True

	def remove_file (self, filename) :
		if not self.is_exist(filename) : return False
		__filepath = os.path.join(self.DIRECTORY, filename)
		try :
			os.remove(__filepath)
		except IOError :
			return False
		else :
			return True

	def remove (self) :
		__files = self.get_list()

		if len(__files) > 0 :
			for i, j in __files.items() :
				if not self.remove_file(i) : return False
			
		return os.rmdir(self.DIRECTORY)

	def save (self, from_filename, to_filename="") :

		if not to_filename.strip() : to_filename = from_filename

		to_filename = self.get_full_path(os.path.basename(to_filename))

		if self.is_exist(to_filename) : return False

		try :
			shutil.copyfile(from_filename, to_filename)
		except IOError :
			return False

		return True


"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "Attachment.py"


