# -*- coding: utf-8 -*-
#    Copyright (C) 2005 Spike^ekipS <spikeekips@gmail.com>
#
#    http://vee.kldp.net
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import sys, os, time, gtk
import Conf__

#-------------------------------------------------------------------
# GConf
# GLOBAL configuration values.
GLOBAL_FONT_SYSTEM_DEFAULT		= "/desktop/gnome/interface/monospace_font_name"

# LOCAL configuration values.
LOCAL_ROOT									=	"/apps/wee/"
SCHEMA_ROOT									=	"/schemas/apps/wee/"
SCHEMA_FILE									=	\
	os.path.join(Conf__.DIR_LIBFILE, "wee.schema")

SCHEMA = {
	"latest-window-geometry" : {
		"key" : LOCAL_ROOT + "latest_window_geometry",
		"schema" : SCHEMA_ROOT + "latest_window_geometry",
		"type" : "string",
		"default" : "750,600,10,10",
	},
	"show-shortcut" : {
		"key" : LOCAL_ROOT + "show_shortcut",
		"schema" : SCHEMA_ROOT + "show_shortcut",
		"type" : "bool",
		"default" : True,
	},
	"show-menubar" : {
		"key" : LOCAL_ROOT + "show_menubar",
		"schema" : SCHEMA_ROOT + "show_menubar",
		"type" : "bool",
		"default" : True,
	},
	"note-time-format" : {
		"key" : LOCAL_ROOT + "note_time_format",
		"schema" : SCHEMA_ROOT + "note_time_format",
		"type" : "string",
		"default" : "Today %-I:%M:%S %p",
	},
	"note-manner" : {
		"key" : LOCAL_ROOT + "note_manner",
		"schema" : SCHEMA_ROOT + "note_manner",
		"type" : "string",
		"default" : "wiki",
	},
	"note-list-update-interval" : {
		"key" : LOCAL_ROOT + "note_list_update_interval",
		"schema" : SCHEMA_ROOT + "note_list_update_interval",
		"type" : "int",
		"default" : 1000,
	},
	"view-finished" : {
		"key" : LOCAL_ROOT + "view_finished",
		"schema" : SCHEMA_ROOT + "view_finished",
		"type" : "bool",
		"default" : True,
	},
}

#-------------------------------------------------------------------
# D&D
DND_TARGET_COLOR = 100
DND_TARGET_BGIMAGE = 101
DND_TARGET_RESET_BG = 102
DND_TARGET_URI_LIST = 103
DND_TARGET_MOZ_URL = 104
DND_TARGET_UTF8_STRING = 105
DND_TARGET_COMPOUND_TEXT = 106
DND_TARGET_TEXT_PLAIN = 107
DND_TARGET_STRING = 108
DND_TARGET_TEXT_PLAIN = 109
DND_TARGET_TEXT = 110

# drag and drop target tables, it from terminal-screen.c in
# gnome-terminal.
DND_TARGET_TABLE = [
	( "application/x-color", 0, DND_TARGET_COLOR ),
	( "property/bgimage",    0, DND_TARGET_BGIMAGE ),
	( "x-special/gnome-reset-background", 0, DND_TARGET_RESET_BG ),
	( "text/uri-list",  0, DND_TARGET_URI_LIST ),
	( "text/x-moz-url",  0, DND_TARGET_MOZ_URL ),
	( "UTF8_STRING", 0, DND_TARGET_UTF8_STRING ),
	( "COMPOUND_TEXT", 0, DND_TARGET_COMPOUND_TEXT ),
	( "TEXT", 0, DND_TARGET_TEXT ),
	( "STRING",     0, DND_TARGET_STRING ),
	( "text/plain", 0, DND_TARGET_TEXT_PLAIN )
]

FILE_NOTES = os.path.join( \
	os.getenv("HOME"), Conf__.DIR_LOCAL, "notes.xml")

FILE_NOTES_REMOVED = os.path.join( \
	os.getenv("HOME"), Conf__.DIR_LOCAL, "removed.xml")

FILE_LABEL = os.path.join( \
	os.getenv("HOME"), Conf__.DIR_LOCAL, "label.xml")

DIR_NOTE = os.path.join(os.getenv("HOME"), Conf__.DIR_LOCAL, "notes")
DIR_NOTE_REMOVED = os.path.join(os.getenv("HOME"), Conf__.DIR_LOCAL, "removed")
DIR_NOTE_ATTACHMENT = os.path.join(os.getenv("HOME"), Conf__.DIR_LOCAL, "attachment")

PREFERENCES_NOTEBOOK_TAB_MAIN = 0
PREFERENCES_NOTEBOOK_TAB_ETC = 1
PREFERENCES_NOTEBOOK_TAB_LABEL = 2

NOTE_NOTEBOOK_TAB_CONTENT = 0
NOTE_NOTEBOOK_TAB_RAW = 1
NOTE_NOTEBOOK_TAB_INFO = 2
NOTE_NOTEBOOK_TAB_SETTING = 3
NOTE_NOTEBOOK_TAB_HISTORY = 4

NOTE_MANNER_WIKI = 0
NOTE_MANNER_PLAIN = 1

NOTE_ALARM_MINUTES = 0
NOTE_ALARM_HOURS = 1

NOTE_TIME_FORMAT_FRIENDLY = 0
NOTE_TIME_FORMAT_FULLY = 1
NOTE_TIME_FORMAT_DIGIT = 2

TREEVIEW_NOTE_PANEL_COLUMN_COLOR = 0
TREEVIEW_NOTE_PANEL_COLUMN_TEXT = 1
TREEVIEW_NOTE_PANEL_COLUMN_UID = 2
TREEVIEW_NOTE_PATH_CREATE_NEW = (0,)

TREEVIEW_DIFF_PANEL_COLUMN_NAME = 0
TREEVIEW_DIFF_PANEL_COLUMN_TIME = 1

TREEVIEW_ATTACHMENT_PANEL_COLUMN_ICON = 0
TREEVIEW_ATTACHMENT_PANEL_COLUMN_FILENAME = 1
TREEVIEW_ATTACHMENT_PANEL_COLUMN_DATE = 2

TREEVIEW_LABEL_PANEL_COLUMN_COLOR = 0
TREEVIEW_LABEL_PANEL_COLUMN_NAME = 1
TREEVIEW_LABEL_PANEL_COLUMN_UID = 2

NOTE_LABEL_SIZE = (20, 30,)
PREFERENCES_LABEL_SIZE = (60, 30,)
COMBOBOX_LABEL_SIZE = (30, 30,)

NOTELIST_PANEL_TREEVIEW_KEYNAME_AVAILABLE = [ \
	"Right", \
	"Left", \
	"Delete", \
	"r", \
	"a", \
	"e", \
	"i", \
	"v", \
	"n", \
	"s", \
	"j", \
	"k", \
	"h", \
	"l", \
]

# combobox for label filtering 
COMBOBOX_SELECT_LABEL_ALL = 0

# combobox for search 
COMBOBOX_SEARCH_WHICH_TITLE = 0
COMBOBOX_SEARCH_WHICH_CONTENT = 1
COMBOBOX_SEARCH_WHICH_ALL = 2


"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "Conf.py"


