# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import func
import sre, os

def format_diff (text_buffer) :

	SRE_DELETED = sre.compile("^\- ")
	SRE_ADDED = sre.compile("^\+ ")
	SRE_EXPLAIN = sre.compile("^\? ")

	n = list()
	b = text_buffer.splitlines(True)
	for i in b :
		i = func.escape_html(i)
		if SRE_DELETED.findall(i) :
			i0 = "<span color=\"red\">%s</span>\n" % i.strip()
		elif SRE_ADDED.findall(i) :
			i0 = "<span color=\"blue\">%s</span>\n" % i.strip()
		elif SRE_EXPLAIN.findall(i) :
			i0 = "<span color=\"grey\">%s</span>\n" % i.strip()
		else :
			i0 = "%s\n" % i

		n.append(i0)

	return "".join(n)

import difflib
def is_changed (old_text_buffer, new_text_buffer) :
	d = difflib.Differ()
	result = list(d.compare(old_text_buffer, new_text_buffer))

	if len(result) > 0 :
		return True
	else :
		return False


"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "Diff.py"


