# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import os, sre
import Conf__, Search

FILE_CSS = "notes.css"

TEMPLATE_HTML = \
"""<html><head>
<meta http-equiv="Content-Type" content="text/html;charset=utf-8" /> 
<style>
%s
//-->
</style>
</head>

<body>
<a id="top"></a>

%s

</body>
</html>"""

TEMPLATE_PLAIN = \
"""<html><head>
<meta http-equiv="Content-Type" content="text/html;charset=utf-8" /> 
<style>
%s
--//>
</style>
</head>
<body>
<a id="top"></a>

<pre class="code">%s</pre>

</body>
</html>"""

class Request :
	DATA = list()

	properties = dict()
	PAGENAME = str()

	def __init__ (self, quoted_title) :
		self.PAGENAME = quoted_title
		self.properties["show-section-numbers"] = "1"

	def write (self, st) :
		self.DATA.append(st)

	def get_property (self, key, default_value=None) :
		if self.properties.has_key(key) :
			return self.properties[key]
		else :
			return default_value

from wiki_manner.formatter.text_html import Formatter
from wiki_manner import wikiutil

class __formatter__ :

	def get_css (self) :
		__css_file = os.path.join(Conf__.DIR_LIBFILE, FILE_CSS)
		if os.path.exists(__css_file) :
			return "".join(open(__css_file, "r").readlines())
		else :
			return str()

class Wiki (__formatter__) :

	REQUEST = None
	FORMATTER = None
	PARSER = None

	def __init__ (self, quoted_title) :
		self.PARSER = wikiutil.importPlugin("parser", "wiki", "Parser")

		self.REQUEST = Request(quoted_title)
		self.FORMATTER = Formatter(self.REQUEST)
		self.REQUEST.formatter = self.FORMATTER

	def format (self, text, search_string=None, **condition) :
		if not search_string :
			__text = text
		else :
			(__compiling_string, __sre_string, ) = \
				Search.compile_string(search_string, **condition)
			__text = __sre_string.sub("<<<\\1>>>", text)

		self.REQUEST.DATA = list()
		self.PARSER(__text, self.REQUEST).format(self.FORMATTER)
		__formatted = TEMPLATE_HTML % \
			(self.get_css(), "".join(self.REQUEST.DATA) )

		return __formatted

class Plain (__formatter__) :
	def __init__ (self) :
		pass

	def format (self, text, search_string=None, **condition) :

		__text = text
		__formatted = TEMPLATE_PLAIN % (self.get_css(), wikiutil.escape(__text))
		return __formatted

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "Formatter.py"


