# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import os, gtk, gnome.vfs

class VFS :

	def __init__ (self) :
		pass

class Icon :

	THEME = None

	DEFAULT_ICON_NAME = "gnome-mime-text"
	STR_MIME_TYPE = "gnome-mime-%s"
	SIZE = 48
	SIZE_THUMBNAIL = 50

	def __init__ (self) :
		self.THEME = gtk.icon_theme_get_default()

	def getName (self, filepath) :
		filepath = os.path.abspath(filepath)

		__mimetype = gnome.vfs.get_mime_type(filepath)
		__icon_name = self.STR_MIME_TYPE % \
			("-".join(__mimetype.split("/")))

		return __icon_name

	def getDefaultPixbuf (self) :
		return self.getPixbufByIcon(self.DEFAULT_ICON_NAME)

	def getNone (self) :
		return func.get_pixbuf_filled_with_color( \
			None, (self.SIZE, self.SIZE, ))

	def getPixbufByIcon (self, icon_name) :
		if not self.THEME.lookup_icon(icon_name, self.SIZE, gtk.ICON_LOOKUP_NO_SVG) :
			return None
		else :
			return self.THEME.load_icon(icon_name, self.SIZE, gtk.ICON_LOOKUP_NO_SVG)

	def getPixbufByFilename (self, filepath) :
		__icon_name = self.getName(filepath)

		return self.getPixbufByIcon(__icon_name)

	def getPreview (self, imagefile) :
		pass

def get_mime_type (filepath) :
	return gnome.vfs.get_mime_type(filepath)

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "GNOME.py"


