# -*- coding: utf-8 -*-
#    Copyright (C) 2005 Spike^ekipS <spikeekips@gmail.com>
#
#    http://vee.kldp.net
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import os, gtk, time
import WIDGET, Conf__, Conf, GConf, i18n, \
	Panel, Window, func, Handler

_ = i18n.gettext()

def on_show_popup_applet (obj, event) :

	Applet(event)

class Applet (WIDGET.WIDGET) :

	WIDGET = None

	def __init__ (self, event) :

		WIDGET.WIDGET.__init__(self, "menu_applet", None)

		self.WIDGET_SELF.popup(None,None,None,event.button,event.time)

		self.GCONF_CLIENT = GConf.Client()
		self.GCONF_CLIENT.add_dir(Conf.LOCAL_ROOT)

		self.connect_handler(dict(), Handler.MENU_APPLET)

		#self.__set_menu_label()

	def __set_menu_label (self) :
		for i, j in i18n.LABEL_MENU_FULL.items() :
			try :
				self.xml.get_widget(i).get_children()[0].set_label(_(j))
			except AttributeError :
				continue

	def on_add_note (self, widget) :
		Window.Note(func.get_uid(), view=Conf.NOTE_NOTEBOOK_TAB_RAW)

	def on_show_window (self, widget) :
		Window.WEE()

def on_show_popup_notelist (treeview, event, STATE, PANEL) :

	if PANEL.IS_REMOVED : return

	if event.button == 3 : NoteList(treeview, event, state=STATE)

class NoteList (WIDGET.WIDGET) :

	NOTE = None
	STATE = None

	PANEL = None
	TREEVIEW = None
	TREESTORE = None
	TREEITER = None

	PATH = tuple()
	VALUE = tuple()

	def __init__ (self, treeview, event, **kwargs) :

		if not kwargs.has_key("state") :
			raise RuntimeError, _("state must be included.")
		else :
			self.STATE = kwargs["state"]
			self.PANEL = self.STATE.get_value("panel-notelist")

		self.NOTE = self.STATE.get_value("note")

		WIDGET.WIDGET.__init__( \
			self, "menu_notelist", None, dict(), Handler.MENU_NOTELIST)

		self.GCONF_CLIENT = GConf.Client()
		self.GCONF_CLIENT.set_path(Conf.LOCAL_ROOT)
		self.GCONF_CLIENT.add_dir(Conf.LOCAL_ROOT)

		# set menu.
		for i, j in i18n.LABEL_MENU_NOTE.items() :
			try :
				self.xml.get_widget(i).get_children()[0].set_label(_(j))
			except AttributeError :
				continue

		self.TREEVIEW = treeview
		(self.TREESTORE, self.TREEITER) = \
			self.TREEVIEW.get_selection().get_selected()

		self.PATH = self.TREESTORE.get_path(self.TREEITER)
		self.UID = self.PANEL.get_value( \
			self.PATH, \
			Conf.TREEVIEW_NOTE_PANEL_COLUMN_UID \
		)

		if self.UID :
			self.DATA = self.NOTE.get_value(self.UID, "asDict")

			if self.DATA["title"].strip() :
				self.WIDGET_SELF.popup(None, None, None, event.button, event.time)

				if int(self.DATA["__timestamp_finished__"]) > 0 :
					self.xml.get_widget("finish_it1").set_property("sensitive", False)
				else :
					self.xml.get_widget("re-entry1").set_property("sensitive", False)

				# if this row has child, de-sensitive 'remove'
				if self.TREESTORE.iter_has_child(self.TREEITER) :
					self.xml.get_widget("remove2").set_property("sensitive", False)

	##############################################################################
	# EVENT HANDLER
	def on_add_subnote (self, widget) :
		Window.Note( \
			func.get_uid(), \
			parent=self.UID, \
			view=Conf.NOTE_NOTEBOOK_TAB_RAW, \
			state=self.STATE \
		)

	def on_preferences (self, widget) :
		Window.Preferences()

	def on_remove (self, widget) :
		if not self.NOTE.remove(self.UID) : return

		self.PANEL.remove(treeiter=self.TREEITER)
		self.NOTE.__export__()

	def on_edit (self, widget) :
		Window.Note(self.UID, view=Conf.NOTE_NOTEBOOK_TAB_RAW, state=self.STATE)

	def on_reentry (self, widget) :

		self.NOTE.set_finish(self.UID, False)
		self.NOTE.__export__()
		self.PANEL.toggle_finish(self.UID, self.TREEITER, False)

	def on_finish (self, widget) :

		self.NOTE.set_finish(self.UID, True)
		self.NOTE.__export__()
		self.PANEL.toggle_finish(self.UID, self.TREEITER, True)


"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "Menu.py"


