# -*- coding: utf-8 -*-
#	Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#	   This program is free software; you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation; either version 2 of the License, or
#	(at your option) any later version.
#
#	This program is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with this program; if not, write to the Free Software
#	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import os, XmlMarshaller, pickle, difflib, time
import Conf, func

NOTE_ITEM_DATA = { \
	"content" : "str", \
}

NOTE_ITEM_DATA_SKEL = { \
	"content" : str(), \
}

class __ONE__ :

	content = str()

	def __init__ (self) :

		self.__xmlname__ = "one"
		self.__xmlcomplextypename__ = "One"
		self.__xmlabbreviatednamespace__ = "pn"

		for i, j in NOTE_ITEM_DATA_SKEL.items() :
			setattr(self, i, j)

	def as_dict (self) :
		__skel = dict()
		for i, j in NOTE_ITEM_DATA.items() :
			try :
				__skel[i] = func.casting(j, (getattr(self, i)))
			except ValueError :
				pass
			except AttributeError :
				pass

		return __skel

	def absorb (self, obj) :
		for i, j in NOTE_ITEM_DATA.items() :
			try :
				__value = func.casting(j, (getattr(obj, i)))
			except AttributeError :
				continue

			self.set_value(i, __value)

	def set_value (self, key, value) :
		if not hasattr(self, key) : return False

		# get type of this value.
		if not NOTE_ITEM_DATA.has_key(key) :
			__type = "str"
		else :
			__type = NOTE_ITEM_DATA[key]

		setattr(self, key, func.casting(__type, value))

		return True

	def get_value (self, key) :
		# get type of value.
		if NOTE_ITEM_DATA.has_key(key) :
			__type = NOTE_ITEM_DATA[key]
		else :
			__type = str

		if not hasattr(self, key) : return None

		try :
			return func.casting(__type, (getattr(self, key)))
		except ValueError :
			return __type()

class One :

	XML_TEMPLATE = \
"""<?xml version=\"1.0\"?>
%s"""

	FILENAME = str()
	TITLE = str()
	ITEM = None

	def __init__ (self, title) :
		self.FILENAME = os.path.join(Conf.DIR_NOTE, "%s.xml" % title)
		self.TITLE = title

		self.__is_exists()

	def __is_exists (self) :
		if not os.path.exists(self.FILENAME) : self.initiate()
		else : self.load()

	def initiate (self) :
		self.ITEM = __ONE__()
		self.ITEM.set_value("title", self.TITLE)
		self.ITEM.set_value("content", " ")

	def load (self) :
		self.get_xml_from_file(self.FILENAME)

	def save (self) :
		__xml_data = self.__marshal()
		f = open(self.FILENAME, "w")
		f.write(__xml_data)
		f.close()

	def __marshal (self) :
		__xml_dumps = str()
		__xml_dumps = XmlMarshaller.marshal(self.ITEM)

		return self.XML_TEMPLATE % __xml_dumps

	def __unmarshal (self, xml_string) :
		self.__get_xml_from_string(xml_string)

	def get_value (self, asDict=False) :
		if not self.ITEM : return None

		if asDict :
			return self.ITEM.as_dict()
		else :
			return self.ITEM

	def remove (self) :
		#try :
		#	del(self.ITEM)
		#except KeyError :
		#	return False

		#try :
		#	os.remove(os.join(Conf.DIR_NOTE, self.FILENAME))
		#except IOError :
		#	raise IOError, "note file, %s does not exists." % self.FILENAME

		# move the content file.
		return True

	def set_value (self, key, value) :
		if not self.ITEM : return False
		if not hasattr(self.ITEM, key) : return False

		return self.ITEM.set_value(key, value)

	##################################################
	def get_xml_from_file (self, filename) :
		try :
			f = open(filename, "r")
			__xml_data = "".join(f.readlines())

			__item = XmlMarshaller.unmarshalText( \
				__xml_data, pathMappings = {"one" : __ONE__, })

		except IOError :
			return False
		else :
			if not hasattr(__item, "one") : return False

			self.ITEM = __item.one

			return True

class New :
	FILENAME = str()
	FILENAME_DIFF = str()
	__FILENAME = str()

	def __init__ (self, title) :
		self.FILENAME = os.path.join(Conf.DIR_NOTE, title)
		self.FILENAME_DIFF = "%s.diff_pkl" % self.FILENAME
		self.__FILENAME = title

		if not os.path.exists(self.FILENAME) : self.__create_new()

	def __create_new (self) :
		try :
			__fd = open(self.FILENAME, "w")
			__fd.close()
		except :
			return False

		return True

	def get_content (self) :
		try :
			__fd = open(self.FILENAME, "r")
			__c = "".join(__fd.readlines())
			__fd.close()
		except :
			return None

		return __c

	def set_content (self, content) :
		try :
			__fd = open(self.FILENAME, "w")
			__fd.write(content)
			__fd.close()
		except :
			return False

		return True

	def rename (self, new_filename) :
		__new_filename = os.path.join(Conf.DIR_NOTE, new_filename)
		try :
			os.rename(self.FILENAME, __new_filename)
		except IOError :
			return False
		else :
			self.TITLE = new_filename
			self.FILENAME = __new_filename
			return True

	def remove (self, uid) :
		try :
			os.rename( \
				os.path.join(Conf.DIR_NOTE, self.__FILENAME), \
				os.path.join(Conf.DIR_NOTE_REMOVED, \
					"%s.%s" % (self.__FILENAME, uid)), \
			)
		except IOError :
			raise IOError, "note file, %s can not be created." % self.__FILENAME

		return True

	def __create_new_diff_pkl (self) :
		"""
		pkl object scheme is dict(), that is,
				key			values
				"content"   str(), the initial content text buffer
				"history"	the list of tuples, (diffed time, diffed text, )

		"""

		__data = dict()
		__data["history"] = list()

		fd = file(self.FILENAME_DIFF, "w")
		pickle.dump(__data, fd)
		fd.close()

	def __load_diff_pkl (self) :
		"""
		@return : list, pickle.load(file descriptor)
		"""
		if not os.path.isfile(self.FILENAME_DIFF) :
			self.__create_new_diff_pkl()

		__data = pickle.load(file(self.FILENAME_DIFF, "r"))

		# check loaded object
		if not __data.has_key("history") :
			self.__create_new_diff_pkl()
			__data = pickle.load(file(self.FILENAME_DIFF, "r"))

		return __data

	def __save_diff_pkl (self, data) :
		if not data.has_key("history") :
			return False

		fd = file(self.FILENAME_DIFF, "w")
		pickle.dump(data, fd)
		fd.close()

		return True

	def make_diff (self, new_content) :
		D = difflib.Differ()
		__d = list( \
			D.compare( \
				("%s\n" % self.get_content()).splitlines(True), \
				("%s\n" % new_content).splitlines(True) \
			)
		)

		if len(__d) < 1 :
			return False
		else :
			__history = "".join(__d)
			__data = self.__load_diff_pkl()
			__data["history"].append( ( int(time.time()), __history, ) )
			if not self.__save_diff_pkl(__data) :
				return False

		return True

	def restore (self, time) :
		__history = self.getListDiff()

		__diff = ""
		for i, j in __history :
			if i == time :
				__diff = list(difflib.restore(j.splitlines(True), 2))
				break

		if not __diff : return None

		return "".join(__diff)

	def getDiff (self, time) :
		__history = self.getListDiff()

		for i, j in __history :
			if i == time :
				return j

		return None

	def getListDiff (self) :
		__data = self.__load_diff_pkl()
		__history = list(__data["history"])

		# reverse sort,
		__history.sort()
		__history.reverse()

		return __history

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "NoteItem.py"


