# -*- coding: utf-8 -*-
#	Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#	   This program is free software; you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation; either version 2 of the License, or
#	(at your option) any later version.
#
#	This program is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with this program; if not, write to the Free Software
#	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import os, XmlMarshaller, time
import func, NoteItem

NOTES_ITEM_DATA = { \
	"title" : "str", \
	"__uid__" : "str", \
	"__parent__" : "str", \
	"__timestamp_added__" : "int", \
	"__timestamp_finished__" : "int", \
	"__timestamp_last_modified__" : "int", \
	"font" : "str", \
	"geometry" : "str", \
	"manner" : "str", \
	"alarm" : "str", \
	"time_to_alarm" : "int", \
	"label" : "str", \
}

NOTES_ITEM_DATA_SKEL = { \
	"title" : str(), \
	"__uid__" : str(), \
	"__parent__" : str(), \
	"__timestamp_added__" : int(), \
	"__timestamp_finished__" : int(), \
	"__timestamp_last_modified__" : int(), \
	"font" : str(), \
	"geometry" : str(), \
	"manner" : str(), \
	"alarm" : str(), \
	"time_to_alarm" : int(), \
	"label" : str(), \
}

UID_NO_PARENT = "-1"

class One :

	__uid__ = str()
	__parent__ = UID_NO_PARENT
	__timestamp_added__ = int()
	__timestamp_last_modified__ = int()
	__timestamp_finished__ = int()

	title = str()
	font = str()
	geometry = str()
	manner = str()
	alarm = str()
	time_to_alarm = int()
	label = str()

	NOTE = None

	def __init__(self, uid=str()) :

		self.__xmlname__ = "one"
		self.__xmlcomplextypename__ = "One"
		self.__xmlattr__ = \
			[ \
				"__uid__", \
				"__parent__", \
				"__timestamp_last_modified__", \
				"__timestamp_added__", \
				"__timestamp_finished__", \
			]
		self.__xmlabbreviatednamespace__ = "pn"

		for i, j in NOTES_ITEM_DATA_SKEL.items() :
			setattr(self, i, j)

		self.__uid__ = uid

	def as_dict (self) :
		__skel = dict()
		for i, j in NOTES_ITEM_DATA.items() :
			try :
				__skel[i] = func.casting(j, (getattr(self, i)))
			except ValueError, AttributeError :
				pass

		return __skel

	def absorb (self, obj) :
		for i, j in NOTES_ITEM_DATA.items() :
			try :
				__value = func.casting(j, (getattr(obj, i)))
			except AttributeError :
				continue

			self.set_value(i, __value)

	def set_value (self, key, value) :
		if not hasattr(self, key) : return False

		# get type of this value.
		if not NOTES_ITEM_DATA.has_key(key) :
			__type = "str"
		else :
			__type = NOTES_ITEM_DATA[key]

		setattr(self, key, func.casting(__type, value))

		return True

	def get_value (self, key) :
		# get type of value.
		if NOTES_ITEM_DATA.has_key(key) :
			__type = NOTES_ITEM_DATA[key]
		else :
			__type = str

		if not hasattr(self, key) : return None

		try :
			return func.casting(__type, (getattr(self, key)))
		except ValueError :
			return __type()

class Them :

	ITEM_LIST = dict()
	XML_TEMPLATE = \
"""<?xml version=\"1.0\"?>
%s"""

	FILE = None
	ITEM_ACTIVE = dict()

	STATE = None
	REMOVED = None

	def __init__ (self, **kwargs) :
		if not kwargs.has_key("state") :
			raise "State must be given."
		else :
			self.STATE = kwargs["state"]
			self.REMOVED = self.STATE.get_value("note-removed")

	def __len__ (self) :
		return len(self.ITEM_LIST)

	def is_valid_uid (self, uid) :
		if not self.ITEM_LIST.has_key(uid) :
			return False
		else :
			return True

	def set_finish (self, uid, is_finish=True) :
		if not self.is_valid_uid(uid) : return

		__item = self.ITEM_LIST[uid]

		if is_finish :
			__item.set_value("__timestamp_finished__", int(time.time()))
			if self.ITEM_ACTIVE.has_key(uid) :
				del(self.ITEM_ACTIVE[__item.__uid__])
		else :
			__item.set_value("__timestamp_finished__", int())
			self.ITEM_ACTIVE[__item.__uid__] = True

	def add_item (self, __item) :
		if not isinstance(__item, One) : return False
		if not hasattr(__item, "__uid__") : return False
		if self.is_valid_uid(__item.__uid__) : return False

		self.ITEM_LIST[__item.__uid__] = __item

		if __item.__timestamp_finished__ < 1 :
			self.ITEM_ACTIVE[__item.__uid__] = True

		return True

	def marshal (self) :
		__xml_dumps = str()
		if len(self.ITEM_LIST) < 1 : self.initiate()
		for i in self.ITEM_LIST.values() :
			__xml_dumps += XmlMarshaller.marshal(i)

		return self.XML_TEMPLATE % __xml_dumps

	def unmarshal (self, xml_string) :
		self.__get_xml_from_string(xml_string)

	def add_new (self, uid) :
		if self.is_valid_uid(uid) : return False

		# remember the timestamp value when added.
		__i = One(uid)
		__i.set_value("__timestamp_added__", int(time.time()))
		return self.add_item(__i)

	def rename_note (self, uid, new_title) :
		if not self.is_valid_uid(uid) : return None

		__note = NoteItem.New(self.ITEM_LIST[str(uid)].title)

		if not __note.rename(new_title) : return False

		self.set_value(uid, "title", new_title)
		self.__export__()

		return True

	def __addToRemoved (self, uid) :
		# remember the timestamp value when added.
		__i = self.ITEM_LIST[uid]

		if not self.REMOVED.add_item(__i) :
			return False
		else :
			__i = self.REMOVED.ITEM_LIST[uid]
			__i.set_value("__timestamp_removed__", int(time.time()))

			return True

	def remove (self, uid) :
		if not self.is_valid_uid(uid) : return None

		# add to self.REMOVED
		if not self.__addToRemoved(uid) :
			return False
		else :
			self.REMOVED.__export__()

		__note = NoteItem.New(self.ITEM_LIST[str(uid)].title)

		if not __note.remove(uid) :
			return False
		else :
			if self.ITEM_ACTIVE.has_key(uid) :
				del(self.ITEM_ACTIVE[uid])

			del(self.ITEM_LIST[uid])

			return True

	def getInstanceContent (self, uid) :
		if not self.is_valid_uid(uid) : return None

		return NoteItem.New(self.ITEM_LIST[str(uid)].title)

	def get_value_by_key (self, uid, key) :
		if not self.is_valid_uid(uid) : return None

		return self.ITEM_LIST[str(uid)].get_value(key)

	def get_value (self, uid, asDict=False) :
		if not self.is_valid_uid(uid) : return None

		if asDict :
			return self.ITEM_LIST[str(uid)].as_dict()
		else :
			return self.ITEM_LIST[str(uid)]

	def get_content (self, uid) :
		if not self.is_valid_uid(uid) : return None
		__note = NoteItem.New(self.ITEM_LIST[str(uid)].title)
		__content = __note.get_content()

		return __content

	def set_content (self, uid, value) :
		if not self.is_valid_uid(uid) : return None

		# get the title
		__note = NoteItem.New(self.ITEM_LIST[str(uid)].title)
		__note.set_content(value)
		del(__note)

		return True

	def set_value (self, uid, key, value) :
		"""
		If key is 'title', check the duplication, and it so return -1.
		"""

		if not self.is_valid_uid(uid) : return None

		if hasattr(self.ITEM_LIST[str(uid)], key) :
			if key == "title" :
				if not self.is_valid_title(value) : return -1 
			return self.ITEM_LIST[str(uid)].set_value(key, value)
		else :
			return False

	def __import__ (self, filename) :
		self.ITEM_LIST = dict()
		self.FILE = filename

		if os.path.isfile(filename) :
			self.get_xml_from_file(filename)
		else :
			# initiate
			self.initiate()

	def __export__ (self, filename="") :
		if not filename.strip() or \
				not os.path.isfile(filename) :
			filename = self.FILE

		__xml_data = self.marshal()
		f = open(filename, "w")
		f.write(__xml_data)
		f.close()

	def initiate (self) :
		pass

	def get_uid (self, title) :
		__list = list()

		for i, j in self.ITEM_LIST.items() :
			if j.get_value("title") == title :
				__list.append(i)

		return __list

	def is_valid_title (self, title) :
		for i, j in self.ITEM_LIST.items() :
			if title == j.title :
				return False

		return True

	##################################################
	def get_xml_from_file (self, filename) :
		try :
			f = open(filename, "r")
			__xml_data = "".join(f.readlines())
			self.__get_xml_from_string(__xml_data)
		except IOError :
			pass

	def __get_xml_from_string (self, xml_string) :
		__a = xml_string.strip().split("<one")

		for i in __a :
			try :
				__obj = self.__get_one_obj_from_string("<one%s" % i)
			except :
				continue

			self.add_item(__obj.one)

	def __get_one_obj_from_string (self, xml_string) :
		return XmlMarshaller.unmarshalText( \
			xml_string, pathMappings = {"one" : One, })

	#######################################################
	# LISTING
	def getListByParent (self) :
		"""
		@return : dict()
			__dict[__parent__] = [uid, uid1, uid2, ...]
		"""

		__dict = dict()
		for i in self.ITEM_LIST.values() :
			__parent = i.get_value("__parent__")
			if not __dict.has_key(__parent) :
				__dict[__parent] = list()

			__dict[__parent].append(i.get_value("__uid__"))

		return __dict

	def sort (self, list_by_parent, uid_parent) :

		"""
		@return : (list,which is live, list, which was finished, )
		"""

		if not list_by_parent.has_key(uid_parent) : return list()
		if len(list_by_parent[uid_parent]) < 1 : return list()

		__dict_active = dict()
		__dict_finished = dict()

		for i in list_by_parent[uid_parent] :
			if self.ITEM_LIST[i].get_value("__timestamp_finished__") > 0 :
				__dict_finished.update( \
					{self.ITEM_LIST[i].get_value("__timestamp_finished__") : i})
			else :
				__dict_active.update( \
					{self.ITEM_LIST[i].get_value("__timestamp_last_modified__") : i})

		__ts_active = __dict_active.keys()
		__ts_finished = __dict_finished.keys()
		if len(__ts_active) > 1 :
			__ts_active.sort()
			__ts_active.reverse()
		if len(__ts_finished) > 1 :
			__ts_finished.sort()
			__ts_finished.reverse()

		__list_active = list()
		__list_finished = list()
		[__list_finished.append(__dict_finished[i]) for i in __ts_finished]
		[__list_active.append(__dict_active[i]) for i in __ts_active]

		return (tuple(__list_active), tuple(__list_finished))

	def get_list (self) :
		"""
		get_child() produces the sequence list of items by
		__timestamp_last_modified__ property.
		"""

		__list_active = dict()
		__list_finished = dict()

		for i in self.ITEM_LIST :
			if self.ITEM_LIST[i].get_value("__timestamp_finished__") > 0 :
				__list_finished.update( \
					{self.ITEM_LIST[i].get_value("__timestamp_finished__") : i})
			else :
				__list_active.update( \
					{self.ITEM_LIST[i].get_value("__timestamp_last_modified__") : i})

		__ts_active = __list_active.keys()
		__ts_finished = __list_finished.keys()
		__ts_active.sort()
		__ts_finished.sort()

		__list_all = list()
		[__list_all.append(__list_finished[i]) for i in __ts_finished]
		[__list_all.append(__list_active[i]) for i in __ts_active]

		return __list_all

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "NotesItem.py"


