# -*- coding: utf-8 -*-
#	Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#	   This program is free software; you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation; either version 2 of the License, or
#	(at your option) any later version.
#
#	This program is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with this program; if not, write to the Free Software
#	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import os, XmlMarshaller
import Conf, func

NOTE_ITEM_DATA = { \
	"content" : "str", \
}

NOTE_ITEM_DATA_SKEL = { \
	"content" : str(), \
}

class __ONE__ :

	content = str()

	def __init__ (self) :

		self.__xmlname__ = "one"
		self.__xmlcomplextypename__ = "One"
		self.__xmlabbreviatednamespace__ = "pn"

		for i, j in NOTE_ITEM_DATA_SKEL.items() :
			setattr(self, i, j)

	def as_dict (self) :
		__skel = dict()
		for i, j in NOTE_ITEM_DATA.items() :
			try :
				__skel[i] = func.casting(j, (getattr(self, i)))
			except ValueError :
				pass
			except AttributeError :
				pass

		return __skel

	def absorb (self, obj) :
		for i, j in NOTE_ITEM_DATA.items() :
			try :
				__value = func.casting(j, (getattr(obj, i)))
			except AttributeError :
				continue

			self.set_value(i, __value)

	def set_value (self, key, value) :
		if not hasattr(self, key) : return False

		# get type of this value.
		if not NOTE_ITEM_DATA.has_key(key) :
			__type = "str"
		else :
			__type = NOTE_ITEM_DATA[key]

		setattr(self, key, func.casting(__type, value))

		return True

	def get_value (self, key) :
		# get type of value.
		if NOTE_ITEM_DATA.has_key(key) :
			__type = NOTE_ITEM_DATA[key]
		else :
			__type = str

		if not hasattr(self, key) : return None

		try :
			return func.casting(__type, (getattr(self, key)))
		except ValueError :
			return __type()

class One :

	def __init__ (self, filename) :
		self.FILENAME = os.path.join(Conf.DIR_NOTE_REMOVED, filename)

		if not os.path.exists(self.FILENAME) : self.__create_new()

	def __create_new (self) :
		try :
			__fd = open(self.FILENAME, "w")
			__fd.close()
		except :
			return False

		return True

	def get_content (self) :
		try :
			__fd = open(self.FILENAME, "r")
			__c = "".join(__fd.readlines())
			__fd.close()
		except :
			return None

		return __c

	def set_content (self, content) :
		try :
			__fd = open(self.FILENAME, "w")
			__fd.write(content)
			__fd.close()
		except :
			return False

		return True

	def rename (self, new_filename) :
		__new_filename = os.path.join(Conf.DIR_NOTE_REMOVED, new_filename)
		try :
			os.rename(self.FILENAME, __new_filename)
		except IOError :
			return False
		else :
			self.TITLE = new_filename
			self.FILENAME = __new_filename
			return True

	def remove (self) :
		try :
			os.remove(self.FILENAME)
		except IOError :
			return False
		except OSError :
			return True

		return True

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "RemovedItem.py"


