# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import sre, os
import func, Conf

class Note :
	"""
	CONDITION
		case_insensitive : bool
		exact_match : bool
		regular_expression : bool

		label : str
		title : bool
		content : bool
	"""

	STRING = str()
	CONDITION = dict()
	STRING_COMPILING = str()

	def __init__ (self, **kwargs) :
		if not kwargs.has_key("state") :
			raise RuntimeError, "state must be given."
		else :
			self.STATE = kwargs["state"]
			self.NOTE = self.STATE.get_value("note")

	def set_condition (self, condition) :
		self.CONDITION = condition

	FOUNDS = dict()
	def search (self, string, **condition) :
		self.FOUNDS = dict()

		self.STRING = string
		self.__update_condition(**condition)

		__sre_string = self.__compile_string(string)

		# dig in title and content.
		for i, j in self.NOTE.ITEM_LIST.items() :

			# dig in label
			__label = self.get_condition("label")
			if __label :
				if __label != j.label : continue

			# dig in content
			if self.get_condition("title") :
				__found = __sre_string.findall(func.unquote_filename(j.title))
				if len(__found) > 0 : self.rankUp(i, len(__found))

			if self.get_condition("content") :
				# get the title name and the open the text of it's file.
				filename = os.path.join(Conf.DIR_NOTE, j.title)
				if not os.path.isfile(filename) : continue

				# RANKING
				__found = \
					__sre_string.findall("".join(file(filename, "r").readlines()))
				if len(__found) > 0 : self.rankUp(i, len(__found))

		return self.get_result()

	def rankUp (self, uid, num=1) :
		if not self.FOUNDS.has_key(uid) : self.FOUNDS[uid] = num
		self.FOUNDS[uid] += num

	def get_result (self) :
		__a = dict()
		for i, j in self.FOUNDS.items() :
			if not __a.has_key(j) : __a[j] = list()
			__a[j].append(i)

		__k = __a.keys()
		__k.reverse()

		__result = list()
		for i in __k : __result += __a[i]

		return __result

	def get_condition (self, key) :
		if self.CONDITION.has_key(key) :
			return self.CONDITION[key]
		else :
			return False

	###################################################
	# MISC HANDLER
	def __compile_string (self, string) :

		(self.STRING_COMPILING, __sre_string, ) = \
			compile_string(string, **self.CONDITION)

		return __sre_string

	def __update_condition (self, **new_condition) :
		self.CONDITION.update(new_condition)

def compile_string (string, **condition) :
	__flag = sre.UNICODE

	if condition.has_key("case_insensitive") and condition["case_insensitive"] :
		__flag = __flag | sre.IGNORECASE

	if condition.has_key("regular_expression") and \
			condition["regular_expression"] :
		__compiling_string = string
	else :

		if condition.has_key("exact_match") and condition["exact_match"] :
			__compiling_string = sre.escape(string)
		else :
			__compiling_string = "(%s)" % \
				"|".join([sre.escape(i) \
					for i in sre.compile("[ \t][ \t]*").split(string.strip())])

	__sre_string = sre.compile(__compiling_string, __flag)

	return (__compiling_string, __sre_string, )

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "Search.py"


