# -*- coding: utf-8 -*-
#    Copyright (C) 2005 Spike^ekipS <spikeekips@gmail.com>
#
#    http://vee.kldp.net
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import gtk
import gtk.glade
import os
import Conf__

GLADEFILE = os.path.join(Conf__.DIR_LIBFILE, "wee.glade")

class WIDGET :

	xml = None
	HANDLER = dict()

	def __init__ (self, WINDOWNAME, \
			ROOTWIDGET=None, handler=dict(), handler_template=dict()) :

		self.xml = gtk.glade.XML(GLADEFILE, WINDOWNAME)

		self.WIDGET_SELF = self.xml.get_widget(WINDOWNAME)
		self.WIDGET_ROOT = ROOTWIDGET

		# assign handler.
		if handler and len(handler) > 0 : self.HANDLER = handler

		self.HANDLER["on_quit"] = self.on_quit
		self.HANDLER["on_close"] = self.on_close
		self.connect_handler(handler_template)

	def connect_handler (self, handler_template=dict()) :
		if len(handler_template) < 1 : return

		__handler = dict()

		[__handler.update({i : eval(j)}) for i, j in handler_template.items()]
		self.HANDLER.update(__handler)
		self.xml.signal_autoconnect(self.HANDLER)

	def on_close (self, widget) :
		self.WIDGET_SELF.destroy()
		return

	def on_quit (self, widget) :
		gtk.main_quit()

def get_widget_from_xml (xmlname, widget_name="") :
	xml = gtk.glade.XML(GLADEFILE, xmlname)
	widget_self = xml.get_widget(xmlname)

	if not widget_name :
		return widget_self
	else :
		return xml.get_widget(widget_name)

def set_title (widget, gconf_client, strings, isFilepath=True) :
	__title_format = gconf_client.get_value_by_conf("window-title")

	if not isFilepath :
		__title = "%s : %s" % (strings, _("WEE"))
	else :
		__path_short = os.path.basename(strings)
		__path_full = strings

		__title = \
			__title_format.replace( \
				"%F", __path_full).replace( \
				"%t", __path_short).replace( \
				"%V", _("WEE"))

	widget.set_title(__title)

def get_window_geometry (window) :
	"""
	@return : (width, height, x position, y position,)
	"""
	(w, h) = window.get_size()
	(x, y) = window.get_position()

	return (w, h, x, y)

def set_window_geometry (window, geometry=(100, 100, 0, 0,)) :
	"""
	Notice :
		resize() and set_size_request() will change the window
		size, but set_size_request keep the window from being
		smaller, so here i use resize().
	"""
	(w, h, x, y) = geometry

	#window.set_resize_mode(gtk.RESIZE_PARENT)
	#window.resize(w, h)

	#__dummy_window = gtk.Window()
	#__dummy_window.realize()
	#__dummy_window.show()

	if x and y : window.move(x, y)
	#window.set_size_request(w, h)
	window.resize(w, h)

	#__dummy_window.destroy()

	return

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "WIDGET.py"

