# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import gnome
import gnome.ui
import gtkhtml2, gtk

import time, gobject, sre, os, shutil
import WIDGET, Handler, GConf, \
	Conf, Conf__, i18n, NoteItem, func, Formatter, \
	WEE as WEE_function, Search, Attachment as AttachmentCore, \
	GNOME, Diff

_ = i18n.gettext()

class WEE (WIDGET.WIDGET) :

	STATE = None
	LABEL = None
	NOTE = None
	GCONF_CLIENT = None

	TREESTORE_LABEL = None

	def __init__ (self, **kwargs) :

		if not kwargs.has_key("state") :
			raise ValueError, _("state must be included.")
		else :
			self.STATE = kwargs["state"]
			self.LABEL = self.STATE.get_value("label")
			self.NOTE = self.STATE.get_value("note")

		self.GCONF_CLIENT = GConf.Client()
		self.GCONF_CLIENT.set_path(Conf.LOCAL_ROOT)
		self.GCONF_CLIENT.add_dir(Conf.LOCAL_ROOT)

		WIDGET.WIDGET.__init__(self, "wee", None, dict(), Handler.MAIN_WINDOW)

		# set window geometry to latest window size.
		try :
			__geometry = [int(i) for i in self.GCONF_CLIENT.get_value_by_conf( \
				"latest-window-geometry").split(",")]
		except ValueError :
			__geometry = Conf.SCHEMA["latest-window-geometry"]["default"]

		WIDGET.set_window_geometry(self.WIDGET_SELF, __geometry)

		self.WIDGET_SELF.set_title(_("WEE"))

		for i, j in i18n.LABEL_NOTELIST.items() :
			self.xml.get_widget(i).set_label(_(j))

		self.__install_accel_group()

		self.xml.get_widget("toolbar1").hide()
		self.xml.get_widget("statusbar1").hide()

		################################################################
		self.STATE.set_value("widget-wee", self.WIDGET_SELF)
		self.STATE.set_value("treeview-notelist", \
			self.xml.get_widget("treeview_note"))

		# set menubar.
		self.GCONF_NOTIFY_ID_MENUBAR = self.GCONF_CLIENT.CLIENT.notify_add( \
			Conf.SCHEMA["show-menubar"]["key"], self.on_toggle_menubar)

		self.MENUBAR = self.xml.get_widget("menubar1")
		self.STATE.set_value("menubar", self.MENUBAR)

		if self.GCONF_CLIENT.get_value_by_conf("show-menubar") :
			self.MENUBAR.show()
		else :
			self.MENUBAR.hide()

		# SET FILTER
		__expander = self.xml.get_widget("expander5")
		__expander.set_expanded(False)
		self.xml.get_widget("vbox77").hide()

		__expander = self.xml.get_widget("expander7")
		__expander.set_expanded(False)

		__checkbutton_view_finished = self.xml.get_widget("checkbutton21")
		__checkbutton_view_finished.set_active( \
			self.GCONF_CLIENT.get_value_by_conf("view-finished"))

		# set menu label.
		for i, j in i18n.LABEL_MAIN_MENU.items() :
			__m = self.xml.get_widget(i)
			if __m is None : continue
			__m.get_children()[0].set_label(_(j))

		# search entry
		__eventbox_search = self.xml.get_widget("eventbox6")
		__eventbox_search.connect("key-release-event", self.on_search_enter)

		# set label filter
		__combobox = self.xml.get_widget("combobox15")

		# create a CellRenderers to render the data
		__cell1 = gtk.CellRendererPixbuf()
		__cell1.set_property("xalign", 0.0)
		__cell1.set_fixed_size(Conf.COMBOBOX_LABEL_SIZE[0] + 10, -1)

		__cell2 = gtk.CellRendererText()
		__cell2.set_property("xalign", 0.0)

		__cell3 = gtk.CellRendererText()

		self.TREESTORE_LABEL = gtk.TreeStore(gtk.gdk.Pixbuf, str, str)
		__combobox.set_model(self.TREESTORE_LABEL)

		# add columns to treeview
		__combobox.pack_start(__cell1, False)
		__combobox.pack_start(__cell2, False)

		__combobox.set_attributes(__cell1, pixbuf=0)
		__combobox.set_attributes(__cell2, text=1)

		# append "view all"
		__pixbuf = func.get_pixbuf_filled_with_color( \
			None, Conf.COMBOBOX_LABEL_SIZE)
		self.TREESTORE_LABEL.append( \
			None, [__pixbuf , _("View All"), "__view_all__", ])

		self.TREESTORE_LABEL.append( \
			None, [__pixbuf , _("View Removed"), "__view_removed__", ])

		for i in self.LABEL.ITEM_LIST.keys() :
			__data = self.LABEL.get_value(i, "asDict")
			if not __data : continue

			if __data["is_default"] :
				__name = "%s (%s)" % (__data["name"], _("Default"), )
			else :
				__name = __data["name"]

			__pixbuf = func.get_pixbuf_filled_with_color( \
				__data["color"], Conf.COMBOBOX_LABEL_SIZE)
			self.TREESTORE_LABEL.append(None, [__pixbuf , __name, i, ])

		__combobox.set_active(Conf.COMBOBOX_SELECT_LABEL_ALL)

		self.STATE.set_value("combobox-label-notelist", __combobox)

		# set label filter
		__combobox = self.xml.get_widget("combobox16")
		__combobox.insert_text( \
			Conf.COMBOBOX_SEARCH_WHICH_TITLE, _("In the title"))
		__combobox.insert_text( \
			Conf.COMBOBOX_SEARCH_WHICH_CONTENT, _("In the content"))
		__combobox.insert_text(Conf.COMBOBOX_SEARCH_WHICH_ALL, _("All"))
		__combobox.set_active(Conf.COMBOBOX_SEARCH_WHICH_ALL)

		import Panel
		self.PANEL = Panel.NoteList( \
			self.xml, \
			state=self.STATE, \
		)
		self.STATE.set_value("panel-notelist", self.PANEL)

	##################################################
	# define HANDLER
	def on_toggle_expander_filtering (self, widget) :
		if self.xml.get_widget("expander5").get_expanded() :
			self.xml.get_widget("vbox77").hide()
		else :
			self.xml.get_widget("vbox77").show()

	def ac_toggle_search_expanded (self, widget, parm1, keyval, parm3) :

		__expander = self.xml.get_widget("expander5")
		if gtk.gdk.keyval_name(keyval) == "Escape" :
			if not __expander.get_expanded() : return

			__expander.emit("activate")
			self.xml.get_widget("treeview_note").grab_focus()
			self.__go_back_notelist()
			return

		__expander.emit("activate")
		if __expander.get_expanded() :
			self.xml.get_widget("entry25").set_text("")
			self.xml.get_widget("entry25").grab_focus()
		else :
			self.xml.get_widget("treeview_note").grab_focus()
			self.__go_back_notelist()

	def on_search_enter (self, widget, event) :
		if event.type == gtk.gdk.KEY_RELEASE :
		 	__keyname = func.get_keyname(event, ignore_shift=True)

			if __keyname not in ["Return", ] : return

			self.__search()

	def on_search (self, widget) :
		return self.__search()

	def __search (self) :
		__entry_search = self.xml.get_widget("entry25")
		__string = __entry_search.get_text()

		if not __string.strip() : return

		# get condition
		__condition = { \
			"label" : None, \
			"case_insensitive" : False, \
			"exact_match" : False, \
			"regular_expression" : False, \
			"title" : False, \
			"content" : False, \
		}

		# get label condition
		__treeiter_label = self.xml.get_widget("combobox15").get_active_iter()
		try :
			__uid_label = self.TREESTORE_LABEL.get_value(__treeiter_label, 2)
		except TypeError :
			return

		if __uid_label != "__view_all__" :
			__condition["label"] = __uid_label

		if self.xml.get_widget("checkbutton22").get_active() :
			__condition["case_insensitive"] = True

		if self.xml.get_widget("checkbutton23").get_active() :
			__condition["exact_match"] = True

		if self.xml.get_widget("checkbutton24").get_active() :
			__condition["regular_expression"] = True

		__combobox_which = self.xml.get_widget("combobox16").get_active()
		if __combobox_which == Conf.COMBOBOX_SEARCH_WHICH_ALL :
			__condition["title"] = True
			__condition["content"] = True
		elif __combobox_which == Conf.COMBOBOX_SEARCH_WHICH_TITLE :
			__condition["title"] = True
		elif __combobox_which == Conf.COMBOBOX_SEARCH_WHICH_CONTENT :
			__condition["content"] = True

		import Panel
		s = Search.Note(state=self.STATE)
		list_uid = s.search(__string, **__condition)

		self.STATE.set_value("search-condition", __condition)
		self.STATE.set_value("search-string", __string)

		self.PANEL.IS_SEARCH_RESULT = True
		self.PANEL.insert_search_result(list_uid)

		__entry_search.grab_focus()
		__entry_search.set_position(len(__string))

	def on_back_list (self, widget) :
		self.__go_back_notelist()

	def __go_back_notelist (self) :
		self.PANEL.IS_SEARCH_RESULT = False
		self.PANEL.IS_REMOVED = False
		__combobox = self.xml.get_widget("combobox15")
		__treeiter = __combobox.get_active_iter()

		try :
			__uid_label = self.TREESTORE_LABEL.get_value(__treeiter, 2)
		except TypeError :
			return

		filter = dict()

		if __uid_label not in ["__view_all__", "__view_removed__",] :
			filter["uid_label"] = __uid_label

		filter["view_finished"] = self.GCONF_CLIENT.get_value_by_conf("view-finished")

		self.PANEL.insert_data(**filter)

		if __uid_label == "__view_removed__" : __combobox.set_active(0)

	def on_filter_view_label (self, widget) :
		if not hasattr(self, "PANEL") : return

		if self.PANEL.IS_SEARCH_RESULT : # in search mode
			self.__search()
		else : # in normal note list mode.
			self.__filter_view()

	def __filter_view (self) :
		__treeiter = self.xml.get_widget("combobox15").get_active_iter()

		try :
			__uid_label = self.TREESTORE_LABEL.get_value(__treeiter, 2)
		except TypeError :
			return

		filter = dict()
		filter["view_finished"] = self.GCONF_CLIENT.get_value_by_conf("view-finished")
		filter["uid_label"] = __uid_label

		self.PANEL.insert_data(**filter)

	def on_toggle_view_finished (self, widget) :
		if not hasattr(self, "PANEL") : return

		self.GCONF_CLIENT.set_value_by_conf("view-finished", widget.get_active())

		__treeiter = self.xml.get_widget("combobox15").get_active_iter()
		try :
			__uid_label = self.TREESTORE_LABEL.get_value(__treeiter, 2)
		except TypeError :
			return

		filter = dict()
		if __uid_label != "__view_all__" :
			filter["uid_label"] = __uid_label

		self.PANEL.insert_data(**filter)

	def __refresh_panel (self) :
		self.PANEL.TREESTORE.clear()

		# reset the combobox entries.
		for i in self.LABEL.ITEM_LIST.keys() :
			__data = self.LABEL.get_value(i, "asDict")
			if not __data : continue

			if __data["is_default"] :
				__name = "%s (%s)" % (__data["name"], _("Default"), )
			else :
				__name = __data["name"]

			__pixbuf = func.get_pixbuf_filled_with_color( \
				__data["color"], Conf.PREFERENCES_LABEL_SIZE)
			self.PANEL.TREESTORE.append(None, [__pixbuf , __name, i, ])

	def on_toggle_menubar (self, client, parm1, parm2, parm3) :
		__is_activate = \
			self.GCONF_CLIENT.get_value_from_value(parm2.get_value())

		if __is_activate :
			self.MENUBAR.show()
		else :
			self.MENUBAR.hide()

	def on_preferences (self, widget) :
		Preferences(state=self.STATE)

	def on_help (self, widget) :
		pass

	def on_add_note (self, widget) :
		treeview = self.xml.get_widget("treeview_note")
		__uid = func.get_uid()
		Note(__uid, path=(0,), treeview=treeview, state=self.STATE)

	def on_about (self, widget) :
		About()

	def on_close (self, widget, parm0=None) :
		self.STATE.set_value("widget-wee", None)
		self.STATE.set_value("panel-notelist", None)

		self.PANEL.remove_timeout_elapsed_time()

		del(self.PANEL)

		# save the window geometry in gconf.
		__geometry = list()
		[__geometry.append(str(i)) \
			for i in WIDGET.get_window_geometry(self.WIDGET_SELF)]

		self.GCONF_CLIENT.set_value_by_conf("latest-window-geometry", ",".join(__geometry))

		WIDGET.WIDGET.on_close(self, widget)

		return True

	def ac_close (self, widget, parm1, parm2, parm3) :
		self.on_close(widget)

		return True

	def __install_accel_group (self) :
		__keys_and_methods = { \
			"<Control>f" : self.ac_toggle_search_expanded, \
			"Escape" : self.ac_toggle_search_expanded, \
			"<Control>q" : self.ac_close, \
		}

		__GROUP = gtk.AccelGroup()
		for keys, methods in __keys_and_methods.items() :
			__key, __mod = gtk.accelerator_parse(keys)
			__GROUP.connect_group( \
				__key, __mod, \
				gtk.ACCEL_VISIBLE, methods \
			)

		self.WIDGET_SELF.add_accel_group(__GROUP)

class ErrorDuplicatedTitle (WIDGET.WIDGET) :

	def __init__ (self, widget_to_be_focused, **kwargs) :

		if not kwargs.has_key("title") :
			raise RuntimeError, "title is missing.."

		self.WIDGET_TO_BE_FOCUSED = widget_to_be_focused

		WIDGET.WIDGET.__init__(self, "error_duplicated_title", \
			None, dict(), Handler.ERROR_DUPLICATED_TITLE)

		self.WIDGET_SELF.set_title(_("ERROR : Title is duplicated."))
		self.xml.get_widget("label332").set_label( \
			_("<span size=\"larger\">Title, <span weight=\"bold\">\"%s\"</span> is duplicated.</span>") % \
				kwargs["title"])

		#for i, j in i18n.DIALOG_ERROR_ENTER_TEXT.items() :
		#	self.xml.get_widget(i).set_label(_(j))

	def on_close (self, widget) :
		self.WIDGET_TO_BE_FOCUSED.grab_focus()

		WIDGET.WIDGET.on_close(self, widget)

class ErrorEnterText (WIDGET.WIDGET) :

	CALLBACK_FUNCTIONS = None

	def __init__ (self, widget_to_be_focused, **kwargs) :
		WIDGET.WIDGET.__init__(self, "error_enter_text", \
			None, dict(), Handler.ERROR_ENTER_TEXT)

		self.WIDGET_SELF.set_title(_("ERROR : Enter the \"Title\" text."))
		self.WIDGET_TO_BE_FOCUSED = widget_to_be_focused


		if not kwargs.has_key("callback_functions") :
			raise ValueError, _("callback_functions must be given.")
		else :
			self.CALLBACK_FUNCTIONS = kwargs["callback_functions"]

		for i, j in i18n.DIALOG_ERROR_ENTER_TEXT.items() :
			self.xml.get_widget(i).set_label(_(j))

	def on_no (self, widget) :
		self.WIDGET_SELF.destroy()
		self.WIDGET_TO_BE_FOCUSED.grab_focus()

	def on_close (self, widget) :
		self.WIDGET_SELF.destroy()
		self.CALLBACK_FUNCTIONS["on_close"]()

class Alarm (WIDGET.WIDGET) :

	UID = None
	STATE = None

	def __init__ (self, message, uid, **kwargs) :
		WIDGET.WIDGET.__init__( \
			self, "note_alarm_dialog" , None, dict(), Handler.ALARM)

		self.WIDGET_SELF.set_title(_("Alarming.................. : WEE"))
		for i, j in i18n.LABEL_ALARM_DIALOG.items() :
			self.xml.get_widget(i).set_label(_(j))

		self.UID = uid

		if not kwargs.has_key("state") :
			raise RuntimeError, "state must be given."
		else :
			self.STATE = kwargs["state"]

		__s = "<span weight=\"bold\" size=\"large\">%s</span>" % message

		label = self.xml.get_widget("label276")
		label.set_label(__s)

	def on_view_note (self, widget) :
		Note( \
			self.UID, view=Conf.NOTE_NOTEBOOK_TAB_CONTENT, state=self.STATE)

		self.on_close(widget)

class EditLabel (WIDGET.WIDGET) :

	STATE = None
	TREEVIEW = None
	TREESTORE = None
	UID = None
	PATH = None
	DATA = None
	TEXTBUFFER = None

	ACTION = "add"

	def __init__ (self, **kwargs) :

		if not kwargs.has_key("state") :
			raise ValueError, _("state must be included.")
		else :
			self.STATE = kwargs["state"]
			self.LABEL = self.STATE.get_value("label")

		if kwargs.has_key("action") : self.ACTION = kwargs["action"]

		if kwargs.has_key("treeview") :
			self.TREEVIEW = kwargs["treeview"]

		WIDGET.WIDGET.__init__(self, "edit_label", \
			None, dict(), Handler.LABEL)

		(self.TREESTORE, self.TREEITER) = \
			self.TREEVIEW.get_selection().get_selected()

		if not self.TREEITER or self.ACTION == "add" : # add
			self.UID = func.get_uid()
			self.TEXTBUFFER = self.xml.get_widget("textview2").get_buffer()
		else : # edit
			self.PATH = self.TREESTORE.get_path(self.TREEITER)
			self.UID = self.__get_uid()
			self.DATA = self.LABEL.get_value(self.UID, "asDict")

			# name
			self.xml.get_widget("entry23").set_text(self.DATA["name"])

			# color
			self.xml.get_widget("colorbutton1").set_color( \
				func.str_to_color(self.DATA["color"]))

			# description
			self.TEXTBUFFER = gtk.TextBuffer()
			self.TEXTBUFFER.set_text(self.DATA["description"])
			self.xml.get_widget("textview2").set_buffer(self.TEXTBUFFER)

	def on_ok (self, widget) :
		"""
		Save the label info.
		"""

		__name = self.xml.get_widget("entry23").get_text()
		if not __name.strip() : return

		__colorname = func.color_to_str( \
			self.xml.get_widget("colorbutton1").get_color())

		# get description
		__description = self.TEXTBUFFER.get_text( \
			self.TEXTBUFFER.get_start_iter(), \
			self.TEXTBUFFER.get_end_iter(), \
			True \
		)

		self.LABEL.add_new(self.UID)
		self.LABEL.set_value(self.UID, "name", __name)
		self.LABEL.set_value(self.UID, "color", __colorname)
		self.LABEL.set_value(self.UID, "description", __description)
		self.LABEL.__export__()

		__pixbuf = func.get_pixbuf_filled_with_color( \
			__colorname, Conf.PREFERENCES_LABEL_SIZE)
		if self.ACTION == "add" or not self.TREEITER : # insert new row.
			self.TREESTORE.append(None, [__pixbuf , __name, self.UID, ])
		else : # replace column contents.
			self.TREESTORE.set_value(self.TREEITER, Conf.TREEVIEW_LABEL_PANEL_COLUMN_COLOR, __pixbuf)
			self.TREESTORE.set_value(self.TREEITER, Conf.TREEVIEW_LABEL_PANEL_COLUMN_NAME, __name)

		self.on_close(widget)

	# MISC ########################################
	def __get_uid (self) :
		if not self.TREEITER : return None

		uid = self.TREESTORE.get_value(self.TREEITER, \
			Conf.TREEVIEW_LABEL_PANEL_COLUMN_UID)

		return uid

	def __get_iter (self, path) :
		try :
			__tree_iter = self.TREESTORE.get_iter(path)
		except :
			return None

		return __tree_iter

class About (WIDGET.WIDGET) :
	"""
	 "authors"              GValueArray           : Write
	 "comments"             gchararray            : Read / Write
	 "copyright"            gchararray            : Read / Write
	 "documenters"          GValueArray           : Write
	 "logo"                 GdkPixbuf             : Write
	 "name"                 gchararray            : Read / Write
	 "translator-credits"   gchararray            : Read / Write
	 "version"              gchararray            : Read / Write
	"""

	def __init__ (self) :
		WIDGET.WIDGET.__init__(self, "about")

		for i, j in Conf__.INFO.items() :
			self.WIDGET_SELF.set_property(i, _(j))

	def on_ok (self, widget) :
		self.on_close(widget)

class Note (WIDGET.WIDGET) :
	UID_PARENT = None
	UID = None
	NOTE = None
	NOTE_CONTENT = None
	LABEL = None
	ALARM = None
	DATA = None
	TITLE = None
	TEXTBUFFER_WAS_EDITED = False

	GCONF_CLIENT = None

	TEXTBUFFER_RAW = None
	HTMLVIEW = None
	DOCUMENT = None

	ATTACHMENT = None

	VIEW = Conf.NOTE_NOTEBOOK_TAB_RAW
	CURRENT_LABEL_INDEX = 0

	###################################
	IS_REMOVED = False
	PANEL = None
	PATH = None

	GCONF_NOTIFY_ID_SHORTCUT = None

	TIME_DND_LAST_TREEVIEW = 0
	TIME_DND_LAST_TEXTVIEW = 0

	def __init__ (self, uid, **kwargs) :

		if not kwargs.has_key("state") :
			raise ValueError, _("state must be included.")
		else :
			self.STATE = kwargs["state"]

		if self.STATE.has_key("panel-notelist") :
			self.PANEL = self.STATE.get_value("panel-notelist")

		if kwargs.has_key("is_removed") and kwargs["is_removed"] :
			self.IS_REMOVED = True

		if kwargs.has_key("title") : self.TITLE = kwargs["title"]
		if kwargs.has_key("parent") : self.UID_PARENT = kwargs["parent"]

		self.UID = uid

		if self.IS_REMOVED :
			self.VIEW = kwargs["view"]
			self.NOTE = self.STATE.get_value("note-removed")
		else :
			self.NOTE = self.STATE.get_value("note")

		if self.IS_REMOVED :
			self.VIEW = Conf.NOTE_NOTEBOOK_TAB_CONTENT
		elif kwargs.has_key("view") :
			self.VIEW = kwargs["view"]

		self.LABEL = self.STATE.get_value("label")
		self.ALARM = self.STATE.get_value("alarm")

		self.DATA =  self.NOTE.get_value(uid, "asDict")
		if self.DATA :
			self.DATA["content"] = self.NOTE.get_content(uid)

		#
		# If note of the uid had already existed, self.DATA has also it's own
		# data.
		#
		# If this note window was opened from note list panel, self.PATH and
		# __treeiter is valid.
		#
		if self.DATA and self.PANEL :
			(__treestore, __treeiter) = \
				self.PANEL.WIDGET.get_selection().get_selected()
			self.PATH = __treestore.get_path(__treeiter)

		self.GCONF_CLIENT = GConf.Client()
		self.GCONF_CLIENT.set_path(Conf.LOCAL_ROOT)
		self.GCONF_CLIENT.add_dir(Conf.LOCAL_ROOT)

		# Initialize widget.
		WIDGET.WIDGET.__init__( \
			self, "note_window", None, dict())

		for i, j in i18n.LABEL_NOTE.items() :
			self.xml.get_widget(i).set_label(_(j))

		if self.GCONF_CLIENT.get_value_by_conf("show-shortcut") :
			__template_label = i18n.LABEL_SHORTCUT_NOTE
		else :
			__template_label = i18n.LABEL_SHORTCUT_NOTE_NO

		for i, j in __template_label.items() :
			try :
				self.xml.get_widget(i).set_label(_(j))
			except AttributeError :
				pass

		# set menubar.
		self.GCONF_NOTIFY_ID_SHORTCUT = \
			self.GCONF_CLIENT.CLIENT.notify_add( \
			Conf.SCHEMA["show-shortcut"]["key"], self.on_toggle_shortcut)

		self.__install_accel_group() # add accelerator.

		self.__toolbutton_label_close = self.xml.get_widget( \
			"toolbutton24").get_children()[0].get_children()[0].get_children()[1]
		self.__toolbutton_label_close.set_property("use-markup", True)
		self.__toolbutton_label_close.set_property("justify", gtk.JUSTIFY_CENTER)

		self.__toolbutton_label_finish = self.xml.get_widget( \
			"toolbutton25").get_children()[0].get_children()[0].get_children()[1]
		self.__toolbutton_label_finish.set_property("use-markup", True)
		self.__toolbutton_label_finish.set_property("justify", gtk.JUSTIFY_CENTER)

		self.__toolbutton_label_remove = self.xml.get_widget( \
			"toolbutton26").get_children()[0].get_children()[0].get_children()[1]
		self.__toolbutton_label_remove.set_property("use-markup", True)
		self.__toolbutton_label_remove.set_property("justify", gtk.JUSTIFY_CENTER)

		(self.HTMLVIEW, self.DOCUMENT, ) = self.__create_html_view()
		self.__insert_content_view(str())

		self.__SCROLLEDWINDOW = self.xml.get_widget("scrolledwindow7")
		self.__SCROLLEDWINDOW.add(self.HTMLVIEW)

		self.NOTEBOOK = self.xml.get_widget("notebook6")

		if not self.DATA :
			__title_string = _("New Note")
			self.__toolbutton_label_remove.set_property("sensitive", False)
		else :
			__title_string = _("%s : %s") % \
				(func.unquote_filename(self.DATA["title"]), _("WEE"))
			self.__set_label_finished()

		self.WIDGET_SELF.set_title(__title_string)

		__textview_raw = self.xml.get_widget("textview1")

		if not self.DATA :
			if self.TITLE :
				self.TITLE_UNQUOTED = func.unquote_filename(self.TITLE)
				self.TITLE_QUOTED = self.TITLE
			else :
				self.TITLE_UNQUOTED = str()
				self.TITLE_QUOTED = str()

			__entry_title = self.xml.get_widget("entry22")
			__entry_title.grab_focus()
			self.TEXTBUFFER_RAW = __textview_raw.get_buffer()
			self.NOTEBOOK.set_current_page(Conf.NOTE_NOTEBOOK_TAB_RAW)

			if self.TITLE_UNQUOTED :
				__entry_title.set_text(self.TITLE_UNQUOTED)
		else :
			# get the title.
			self.TITLE_QUOTED = self.DATA["title"]
			self.TITLE_UNQUOTED = func.unquote_filename(self.DATA["title"])

			# SET CONTENT. ########################################
			# raw
			self.TEXTBUFFER_RAW = gtk.TextBuffer()
			if self.DATA["content"] :
				self.TEXTBUFFER_RAW.set_text(self.DATA["content"])
			__textview_raw.set_buffer(self.TEXTBUFFER_RAW)
			__textview_raw.set_property("sensitive", not self.IS_REMOVED)

			__entry = self.xml.get_widget("entry22")
			__entry.set_text( \
				func.unquote_filename(self.DATA["title"]))
			__entry.set_property("sensitive", not self.IS_REMOVED)

			# content
			if self.DATA["content"] :
				self.__insert_content_view(self.DATA["content"])
				self.TEXTBUFFER_RAW.set_modified(False)

			self.NOTEBOOK.set_current_page(Conf.NOTE_NOTEBOOK_TAB_CONTENT)

			# set geometry
			__g = self.NOTE.get_value(self.UID, "asDict")
			try :
				__gg = [int(i) for i in __g["geometry"].split(",")]
			except ValueError :
				__gg = (700, 700, 10, 10,)

			if len(__gg) == 4 :
				WIDGET.set_window_geometry(self.WIDGET_SELF, __gg)

		self.TEXTBUFFER_RAW.connect("changed", self.on_change_buffer)

		############################################################
		# set label button.
		__combobox = self.xml.get_widget("combobox9")

		# create a CellRenderers to render the data
		__cell1 = gtk.CellRendererPixbuf()
		__cell1.set_property("xalign", 0.0)
		__cell1.set_fixed_size(Conf.COMBOBOX_LABEL_SIZE[0] + 10, -1)
		__cell2 = gtk.CellRendererText()
		__cell2.set_property("xalign", 0.0)
		__cell3 = gtk.CellRendererText()

		self.TREESTORE_LABEL = gtk.TreeStore(gtk.gdk.Pixbuf, str, str)
		__combobox.set_model(self.TREESTORE_LABEL)

		# add columns to treeview
		__combobox.pack_start(__cell1, False)
		__combobox.pack_start(__cell2, False)

		__combobox.set_attributes(__cell1, pixbuf=0)
		__combobox.set_attributes(__cell2, text=1)

		__combobox_index = 0
		__combobox_index_default = __combobox_index
		__combobox_index_current = __combobox_index
		for i in self.LABEL.ITEM_LIST.keys() :
			__data = self.LABEL.get_value(i, "asDict")
			if not __data : continue

			if __data["is_default"] :
				__name = "%s (%s)" % (__data["name"], _("Default"), )
				__combobox_index_default = __combobox_index
			else :
				__name = __data["name"]

			if self.DATA and self.DATA["label"] == i :
				__combobox_index_current = __combobox_index

			__pixbuf = func.get_pixbuf_filled_with_color( \
				__data["color"], Conf.COMBOBOX_LABEL_SIZE)
			self.TREESTORE_LABEL.append(None, [__pixbuf , __name, i, ])
			__combobox_index += 1

		# insert edit label.
		if len(self.LABEL.ITEM_LIST) > 0 :
			__pixbuf = func.get_pixbuf_filled_with_color(None, Conf.COMBOBOX_LABEL_SIZE)
			self.TREESTORE_LABEL.append(None, [__pixbuf , _("Edit label"), "__edit_label__", ])

		if self.DATA and __combobox_index_current != __combobox_index_default :
			__combobox_index_default = __combobox_index_current

		self.CURRENT_LABEL_INDEX = __combobox_index_default
		__combobox.set_active(__combobox_index_default)

		# set manner combo button.
		__combobox = self.xml.get_widget("combobox10")
		__combobox.set_property("sensitive", not self.IS_REMOVED)

		__cell1 = gtk.CellRendererText()
		__cell1.set_property("xalign", 0.0)
		__treestore_manner = gtk.TreeStore(str)
		__combobox.set_model(__treestore_manner)
		__combobox.pack_start(__cell1, True)
		__combobox.set_attributes(__cell1, text=0)

		__treestore_manner.append(None, [_("Wiki"), ])
		__treestore_manner.append(None, [_("Plain"), ])

		if not self.DATA :
			__manner = \
				self.GCONF_CLIENT.get_value_by_conf("note-manner")
		else :
			__manner = self.DATA["manner"]

		if __manner == "wiki" :
			__combobox.set_active(Conf.NOTE_MANNER_WIKI)
		else :
			__combobox.set_active(Conf.NOTE_MANNER_PLAIN)

		# info page.
		__label_wiki_title = self.xml.get_widget("label253")
		__label_time_modified = self.xml.get_widget("label258")
		__label_time_added = self.xml.get_widget("label254")
		__label_time_finished = self.xml.get_widget("label259")
		__label_time_finished_colon = self.xml.get_widget("label249")
		__label_time_finished_value = self.xml.get_widget("label255")
		__label_time_finished.hide()
		__label_time_finished_colon.hide()
		__label_time_finished_value.hide()

		if self.DATA :
			__label_time_modified.set_text( \
				WEE_function.format_timestamp( \
					self.GCONF_CLIENT, self.DATA["__timestamp_last_modified__"]))
			__label_wiki_title.set_text(self.TITLE_QUOTED)
			__label_time_added.set_text( \
				WEE_function.format_timestamp( \
					self.GCONF_CLIENT, self.DATA["__timestamp_added__"]))

			if self.DATA["__timestamp_finished__"] > 0 :
				__label_time_finished.show()
				__label_time_finished_colon.show()
				__label_time_finished_value.show()
				__label_time_finished_value.set_text( \
					WEE_function.format_timestamp( \
						self.GCONF_CLIENT, self.DATA["__timestamp_finished__"]))

		# ALARM PAGE ##########################################################

		# Basically gnome dateedit widget make the date select button as "Calendar
		# >", but it's ugly thing, so i did remove 'calendar' label.

		__combobox = self.xml.get_widget("combobox8")
		__combobox.insert_text(Conf.NOTE_ALARM_MINUTES, _("Minutes"))
		__combobox.insert_text(Conf.NOTE_ALARM_HOURS, _("Hours"))
		__combobox.set_active(Conf.NOTE_ALARM_MINUTES)

		__combobox_entry = self.xml.get_widget("comboboxentry1")
		__liststore = gtk.ListStore(gobject.TYPE_STRING, gobject.TYPE_INT)
		__combobox_entry.set_model(__liststore)
		__combobox_entry.set_text_column(0)

		__radiobutton_dialog = self.xml.get_widget("radiobutton1")
		__radiobutton_osd = self.xml.get_widget("radiobutton2")
		__radiobutton_dialog.set_active(True)

		for i in range(1, 11) :
			__liststore.append([str(i), i, ])

		__combobox_entry.set_active(2)

		__text_to_show_alarm = self.xml.get_widget("label275")
		__text_to_show_alarm.set_label("")
		box_show_alarm = self.xml.get_widget("hbox52")
		box_show_alarm.hide()

		__checkbutton_set_alarm = self.xml.get_widget("checkbutton14")
		__checkbutton_set_alarm.set_active(False)
		__checkbutton_set_alarm.set_property("sensitive", not self.IS_REMOVED)

		self.__toggle_alarm_widget(False)

		__expander = self.xml.get_widget("expander1")
		__expander.set_expanded(False)
		__expander.set_property("sensitive", False)

		__dateedit = gnome.ui.DateEdit(int(time.time()), True, False)
		__dateedit.get_children()[1].get_children()[0].get_children()[0].set_label("")
		__dateedit.set_border_width(15)
		__dateedit.show()
		__dateedit.connect("time-changed", self.on_change_time_to_alarm_dateedit)
		__dateedit.connect("date-changed", self.on_change_time_to_alarm_dateedit)

		__expander.add(__dateedit)

		if self.DATA :
			if self.DATA["time_to_alarm"] > time.time() :
				box_show_alarm.show()
				__s = _("Will be alarmed at %s as %s.") % \
					( \
						WEE_function.format_timestamp( \
							self.GCONF_CLIENT, self.DATA["time_to_alarm"]),
						_(self.DATA["alarm"]) \
					)
				__text_to_show_alarm.set_label(__s)

		self.NOTEBOOK.set_current_page(self.VIEW)

		# ATTACHMENT PAGE.
		import Panel
		__kwargs_panel_attachment = { \
			"state" : self.STATE, \
		}

		if self.DATA :
			self.ATTACHMENT = AttachmentCore.Core(self.TITLE_QUOTED)
			__kwargs_panel_attachment["attachment"] = self.ATTACHMENT

		self.PANEL_ATTACHMENT = Panel.Attachment( \
			self.xml, \
			**__kwargs_panel_attachment \
		)

		# HISTORY PAGE
		if self.DATA :
			self.NOTE_CONTENT = self.NOTE.getInstanceContent(uid)

			import Panel
			self.PANEL_DIFF = Panel.Diff( \
				self.xml, state=self.STATE, note=self.NOTE_CONTENT)
			self.PANEL_DIFF.WIDGET_TREEVIEW.connect( \
				"cursor-changed", self.on_cursor_changed_diff)

		self.xml.get_widget("label340").set_text("")
		(self.HTMLVIEW_DIFF, self.DOCUMENT_DIFF, ) = self.__create_html_view()
		__scrolledwindow = self.xml.get_widget("scrolledwindow14")
		__scrolledwindow.add(self.HTMLVIEW_DIFF)

		# set hpaned position.
		self.xml.get_widget("vpaned1").set_position(200)

		###################################################################
		# DND
		self.PANEL_ATTACHMENT.WIDGET_TREEVIEW.connect("drag-data-received", \
			self.on_drag_received_treeview)
		self.PANEL_ATTACHMENT.WIDGET_TREEVIEW.drag_dest_set( \
			gtk.DEST_DEFAULT_MOTION |
			gtk.DEST_DEFAULT_HIGHLIGHT |
			gtk.DEST_DEFAULT_DROP,
			Conf.DND_TARGET_TABLE, gtk.gdk.ACTION_COPY)

		self.PANEL_ATTACHMENT.WIDGET_TREEVIEW.connect("drag-data-get", \
			self.on_drag_get_treeview)
		self.PANEL_ATTACHMENT.WIDGET_TREEVIEW.drag_source_set( \
			gtk.gdk.BUTTON1_MASK, \
			Conf.DND_TARGET_TABLE, \
			gtk.gdk.ACTION_DEFAULT | gtk.gdk.ACTION_COPY \
		)

		###################################################################
		# DND
		__textview_raw.connect("drag-data-received", \
			self.on_drag_received_textview)
		__textview_raw.drag_dest_set( \
			gtk.DEST_DEFAULT_MOTION |
				gtk.DEST_DEFAULT_HIGHLIGHT |
				gtk.DEST_DEFAULT_DROP,
			Conf.DND_TARGET_TABLE, \
			gtk.gdk.ACTION_COPY \
		)

		# connect handler
		self.connect_handler(Handler.NOTE)

	def on_cursor_changed_diff (self, treeview) :
		(__treestore, __treeiter, ) = self.PANEL_DIFF.get_selected()

		__path = self.PANEL_DIFF.get_path(__treeiter)
		__time = self.PANEL_DIFF.get_value( \
			__path, Conf.TREEVIEW_DIFF_PANEL_COLUMN_TIME)

		__diff = self.NOTE_CONTENT.getDiff(int(__time))

		__diff_formated = Diff.format_diff(__diff)
		self.xml.get_widget("label340").set_markup(__diff_formated)

		__text = self.NOTE_CONTENT.restore(int(__time))

		__combobox_manner = self.xml.get_widget("combobox10")
		if __combobox_manner.get_active() == Conf.NOTE_MANNER_WIKI :
			__manner = "wiki"
		else :
			__manner = "plain"

		self.__insert_content_diff(__text, __manner)

	def on_drag_get_treeview (self, treeview, context, selection, info, timestamp):

		if not self.ATTACHMENT : return

		__selection = treeview.get_selection()
		model, iter = __selection.get_selected()

		filename = model.get_value(iter, Conf.TREEVIEW_ATTACHMENT_PANEL_COLUMN_FILENAME)
		__filepath = self.ATTACHMENT.get_full_path(filename)

		__mime_type = GNOME.get_mime_type(__filepath)
		selection.set(__mime_type, 8, __filepath)

		return

	def on_drag_received_treeview \
			(self, widget, context, x, y, selection, targetType, time) :

		if not self.ATTACHMENT : return

		if time == self.TIME_DND_LAST_TREEVIEW : return
		self.TIME_DND_LAST_TREEVIEW = time

		__path = func.get_filename_from_uri(selection.data)
		if not os.path.exists(__path) : return

		# auto upload? YES.
		to_filename = os.path.basename(__path)

		if not self.ATTACHMENT.save(__path, to_filename) : return

		self.PANEL_ATTACHMENT.prepend(to_filename)

	def on_drag_received_textview \
			(self, widget, context, x, y, selection, targetType, time) :

		if time == self.TIME_DND_LAST_TEXTVIEW : return
		self.TIME_DND_LAST_TEXTVIEW = time

		__path = func.get_filename_from_uri(selection.data)

		# get the mime type.
		__mime_type = GNOME.get_mime_type(__path)

		AVAILABLE_TYPE = [ \
			"text", \
		]

		NOT_AVAILABLE_TYPE = [ \
			"video", \
			"audio", \
		]

		if not os.path.exists(__path) : return

		# if file type is media, insert filename.
		# if file type is text, insert filename
		if __mime_type.split("/")[0].lower() in AVAILABLE_TYPE :
			__f = open(__path, "r")
			__text = "\n\n{{{\n%s\n}}}\n" % "".join(__f.readlines())
			__f.close()
		elif __mime_type.split("/")[0].lower() in NOT_AVAILABLE_TYPE or \
				__mime_type :
			__text = "attachment:%s" % os.path.basename(__path)

			# auto upload? YES.

		self.TEXTBUFFER_RAW.insert_at_cursor(__text)

	def ac_zoom_in (self, widget, parm1, parm2, parm3) :
		if self.NOTEBOOK.get_current_page() == Conf.NOTE_NOTEBOOK_TAB_CONTENT :
			self.HTMLVIEW.zoom_in()

	def ac_zoom_out (self, widget, parm1, parm2, parm3) :
		if self.NOTEBOOK.get_current_page() == Conf.NOTE_NOTEBOOK_TAB_CONTENT :
			self.HTMLVIEW.zoom_out()

	def ac_zoom_default (self, widget, parm1, parm2, parm3) :
		if self.NOTEBOOK.get_current_page() == Conf.NOTE_NOTEBOOK_TAB_CONTENT :
			self.HTMLVIEW.zoom_reset()
			self.HTMLVIEW.zoom_in()
			self.HTMLVIEW.zoom_in()

	def ac_view_info (self, widget, parm1, parm2, parm3) :
		self.NOTEBOOK.set_current_page(Conf.NOTE_NOTEBOOK_TAB_INFO)

	def ac_view_raw (self, widget, parm1, parm2, parm3) :
		self.NOTEBOOK.set_current_page(Conf.NOTE_NOTEBOOK_TAB_RAW)
		self.xml.get_widget("textview1").grab_focus()

	def ac_view_content (self, widget, parm1, parm2, parm3) :
		self.NOTEBOOK.set_current_page(Conf.NOTE_NOTEBOOK_TAB_CONTENT)

	def ac_view_alarm (self, widget, parm1, parm2, parm3) :
		self.NOTEBOOK.set_current_page(Conf.NOTE_NOTEBOOK_TAB_SETTING)

	def ac_view_history (self, widget, parm1, parm2, parm3) :
		self.NOTEBOOK.set_current_page(Conf.NOTE_NOTEBOOK_TAB_HISTORY)

	def ac_remove (self, widget, event, parm1, parm2) :
		self.on_remove(widget)

	def ac_toggle_finished (self, widget, event, parm1, parm2) :
		self.on_toggle_finished(widget)

	def ac_focus_title (self, widget, event, parm1, parm2) :
		self.xml.get_widget("entry22").grab_focus()

	# ACTION #######################################
	def on_switch_page (self, widget, page, page_number) :
		self.on_editing_done_content(self, widget)

	def on_attachment_save (self, widget) :
		if not self.ATTACHMENT : return

		FileDialogAttachment(self.TITLE_QUOTED, panel=self.PANEL_ATTACHMENT)

	def on_attachment_open (self, widget) :
		if not self.ATTACHMENT : return

		__filename = self.PANEL_ATTACHMENT.get_value_selected( \
			Conf.TREEVIEW_ATTACHMENT_PANEL_COLUMN_FILENAME)

		if not __filename : return

		FileDialogDownload(self.TITLE_QUOTED, __filename)

	def on_attachment_remove (self, widget) :
		if not self.ATTACHMENT : return

		__filename = self.PANEL_ATTACHMENT.get_value_selected( \
			Conf.TREEVIEW_ATTACHMENT_PANEL_COLUMN_FILENAME)

		if self.PANEL_ATTACHMENT.ATTACHMENT.remove_file(__filename) :
			# remove row in panel.
			(__treestore, __treeiter, ) = self.PANEL_ATTACHMENT.get_selected()
			self.PANEL_ATTACHMENT.remove(treeiter=__treeiter)

			self.TEXTBUFFER_RAW.set_modified(True)

	def on_toggle_shortcut (self, client, parm1, parm2, parm3) :
		__is_activate = \
			self.GCONF_CLIENT.get_value_from_value(parm2.get_value())

		if __is_activate :
			__template_label = i18n.LABEL_SHORTCUT_NOTE
		else :
			__template_label = i18n.LABEL_SHORTCUT_NOTE_NO

		for i, j in __template_label.items() :
			self.xml.get_widget(i).set_label(_(j))

	def on_change_label (self, widget) :
		__treeiter = widget.get_active_iter()
		if __treeiter :
			try :
				__uid_label = self.TREESTORE_LABEL.get_value(__treeiter, 2)
			except TypeError :
				return

			if self.LABEL.is_valid_uid(__uid_label) and \
					__uid_label == "__edit_label__" :
				Preferences( \
					view=Conf.PREFERENCES_NOTEBOOK_TAB_LABEL, \
					state=self.STATE, \
					treestore_label=self.TREESTORE_LABEL, \
					combobox_label=widget \
				)
				widget.set_active(self.CURRENT_LABEL_INDEX)

				return

			if self.DATA :
				__color = self.__store_label()
				self.NOTE.__export__()

				try :
					__color = self.LABEL.get_value(__uid_label, "asDict")["color"]
				except TypeError :
					return

				self.PANEL.set_value( \
					self.PATH, \
					Conf.TREEVIEW_NOTE_PANEL_COLUMN_COLOR, \
					func.get_pixbuf_filled_with_color( \
						__color, Conf.NOTE_LABEL_SIZE) \
				)

	def on_expand_more_detail (self, widget) :
		if not widget.get_expanded() : # expanded
			self.xml.get_widget("label274").set_property("sensitive", False)
			self.xml.get_widget("comboboxentry1").set_property("sensitive", False)
			self.xml.get_widget("combobox8").set_property("sensitive", False)
		else : # not expanded
			self.xml.get_widget("label274").set_property("sensitive", True)
			self.xml.get_widget("comboboxentry1").set_property("sensitive", True)
			self.xml.get_widget("combobox8").set_property("sensitive", True)

	def on_set_alarm (self, widget) :
		self.__toggle_alarm_widget(widget.get_active())

	def on_change_time_to_alarm_dateedit (self, widget) :
		if not self.xml.get_widget("checkbutton14").get_active() :
			return

		__title = self.xml.get_widget("entry22").get_text()
		if not __title.strip() : return

		__time = int(widget.get_time())

		if __time <= time.time() : return

		self.NOTE.set_value(self.UID, "time_to_alarm", __time)
		self.NOTE.set_value(self.UID, "alarm", self.__get_method_alarm())
		self.NOTE.__export__()

	def on_change_time_to_alarm (self, widget) :
		if not self.xml.get_widget("checkbutton14").get_active() :
			return

		__title = self.xml.get_widget("entry22").get_text()
		if not __title.strip() : return

		try :
			__value = int(widget.child.get_text())
		except ValueError :
			return
		else :
			if not __value : return

		__unit = self.xml.get_widget("combobox8").get_active()

		if __unit == Conf.NOTE_ALARM_HOURS :
			__v = __value * (60 * 60)
		else :
			__v = __value * 60

		self.NOTE.set_value(self.UID, "time_to_alarm", int(time.time()) + __v)
		self.NOTE.set_value(self.UID, "alarm", self.__get_method_alarm())
		self.NOTE.__export__()

		# reset alarm
		self.ALARM.reset(self.UID)

	def on_remove (self, widget) :
		if self.NOTE.remove(self.UID) :
			self.PANEL.remove(path=self.PATH)
			self.NOTE.__export__()

		self.on_close(widget)

	def on_change_buffer (self, widget) :
		self.TEXTBUFFER_WAS_EDITED = True

	def on_editing_done_title (self, entry, event) :
		__title = entry.get_text().strip()
		if not __title : return

		if not self.DATA :
			# check the title duplication.
			if not self.NOTE.is_valid_title(func.quote_filename(__title)) :
				if not self.WILL_BE_CLOSED :
					ErrorDuplicatedTitle(entry, title=__title)

				return

			self.NOTE.add_new(self.UID)
			self.NOTE.set_value(self.UID, "__parent__", self.UID_PARENT)

		# if note file already created, rename it to new one.
		if self.TITLE_UNQUOTED.strip() and not self.TITLE :
			if self.TITLE_UNQUOTED.strip() == __title : return

			__ret = self.NOTE.rename_note(self.UID, func.quote_filename(__title))
			if __ret == -1 :
				ErrorDuplicatedTitle(entry, title=__title)
				return
			elif not __ret :
				return
			else :
				self.TITLE_UNQUOTED = __title
				self.TITLE_QUOTED = func.quote_filename(__title)

		if not self.DATA : # when newly created note.
			self.TITLE_UNQUOTED = __title
			self.TITLE_QUOTED = func.quote_filename(__title)

			self.ATTACHMENT = AttachmentCore.Core(self.TITLE_QUOTED)
			self.PANEL_ATTACHMENT.set_attachment(self.ATTACHMENT)

		__this_time = int(time.time())
		self.NOTE.set_value( \
			self.UID, "__timestamp_last_modified__", __this_time)

		__uid_label = self.__store_label()
		self.NOTE.set_value(self.UID, "title", self.TITLE_QUOTED)
		self.NOTE.__export__()

		if not self.PANEL : return

		if not self.DATA :
			if not self.UID_PARENT :
				self.PANEL.add_item( \
					self.UID, \
					self.TITLE_UNQUOTED, \
					__this_time, \
					0, \
					__this_time, \
					__uid_label, \
					False, \
				)
				self.PATH = (1,)
			else :
				__path_parent = self.PANEL.getPathByUID(self.UID_PARENT)

				__iter_parent = self.PANEL.TREESTORE.get_iter(__path_parent)
				__iter = self.PANEL.append_item( \
					__iter_parent, \
					self.UID, \
					func.unquote_filename(self.TITLE_UNQUOTED), \
					__this_time, \
					0, \
					__this_time, \
					__uid_label, \
				)
				self.PATH = self.PANEL.getPathByUID(self.UID)

			self.DATA = self.NOTE.get_value(self.UID, "asDict")
		else :
			if len(self.PATH) == len(Conf.TREEVIEW_NOTE_PATH_CREATE_NEW) :
				self.PANEL.move(self.PATH, Conf.TREEVIEW_NOTE_PATH_CREATE_NEW)

			if self.DATA["__timestamp_finished__"] > 0 :
				__string = WEE_function.note_format_string_finished( \
					self.GCONF_CLIENT, \
					self.TITLE_UNQUOTED, __this_time, \
					self.DATA["__timestamp_added__"])
			else :
				__string = \
					WEE_function.note_format_string( \
						self.GCONF_CLIENT, \
						self.TITLE_UNQUOTED, \
						__this_time, self.DATA["__timestamp_added__"])

			self.PANEL.set_value( \
				self.PATH, \
				Conf.TREEVIEW_NOTE_PANEL_COLUMN_TEXT, \
				__string \
			)

	def on_editing_done_content (self, textview, event) :
		if not self.NOTE.is_valid_uid(self.UID) : return
		if not self.TEXTBUFFER_RAW.get_modified() : return
		self.TEXTBUFFER_RAW.set_modified(False)

		__content = self.TEXTBUFFER_RAW.get_text( \
			self.TEXTBUFFER_RAW.get_start_iter(), \
			self.TEXTBUFFER_RAW.get_end_iter(), \
			True \
		)

		# check the diffs.
		if not Diff.is_changed(__content, self.NOTE.get_content(self.UID)) :
			return
		else :
			if not self.NOTE_CONTENT.make_diff(__content) :
				print "failed to create diff."
			else :
				self.PANEL_DIFF.insert_row()

		__combobox_manner = self.xml.get_widget("combobox10")
		if __combobox_manner.get_active() == Conf.NOTE_MANNER_WIKI :
			__manner = "wiki"
		else :
			__manner = "plain"

		self.__insert_content_view(__content, __manner)

		__this_time = int(time.time())
		#self.NOTE.set_value(self.UID, "content", __content)
		self.NOTE.set_content(self.UID, __content)
		self.NOTE.set_value( \
			self.UID, "__timestamp_last_modified__", __this_time)

		self.NOTE.set_value(self.UID, "manner", __manner)
		self.__store_label()
		self.NOTE.__export__()

		if not self.PANEL : return

		if self.DATA["__timestamp_finished__"] < 1 :
			if len(self.PATH) == len(Conf.TREEVIEW_NOTE_PATH_CREATE_NEW) :
				self.PANEL.move(self.PATH, Conf.TREEVIEW_NOTE_PATH_CREATE_NEW)

			self.PATH = (1,)

	WILL_BE_CLOSED = False

	def __close (self, widget) :
		self.HTMLVIEW = None
		self.DOCUMENT = None

		# remove gconf.notify.
		self.GCONF_CLIENT.CLIENT.notify_remove(self.GCONF_NOTIFY_ID_SHORTCUT)

		if hasattr(self, "PANEL_ATTACHMENT") :	del(self.PANEL_ATTACHMENT)

		WIDGET.WIDGET.on_close(self, widget)

	def on_close (self, widget, event=None) :

		__content = self.TEXTBUFFER_RAW.get_text( \
			self.TEXTBUFFER_RAW.get_start_iter(), \
			self.TEXTBUFFER_RAW.get_end_iter(), \
			True \
		)

		callback_functions = {"on_close" : self.WIDGET_SELF.destroy}
		if not self.DATA and not __content.strip() :
			#if not self.WILL_BE_CLOSED :
			#	ErrorEnterText( \
			#		self.xml.get_widget("entry22"),
			#		callback_functions=callback_functions \
			#	)

			#return True
			self.WILL_BE_CLOSED = True

			self.__close(widget)
			return

		if self.TEXTBUFFER_RAW.get_modified() :
			self.xml.get_widget("textview1").emit( \
				"focus-out-event", gtk.gdk.Event(gtk.gdk.BUTTON_PRESS))

		# save time to alarm
		self.on_change_time_to_alarm(self.xml.get_widget("comboboxentry1"))

		# remember the window size.
		if self.DATA :
			__geometry = list()
			[__geometry.append(str(i)) \
				for i in WIDGET.get_window_geometry(self.WIDGET_SELF)]

			self.NOTE.set_value(self.UID, "geometry", ",".join(__geometry))

			# remember the label info.
			self.__store_label()
			self.NOTE.__export__()

		self.__close(widget)

	def on_toggle_finished (self, widget) :
		if not self.DATA : return

		if int(self.DATA["__timestamp_finished__"]) > 0 :
			was_finish = True
		else :
			was_finish = False

		self.NOTE.set_finish(self.UID, not was_finish)
		self.NOTE.__export__()

		self.DATA = self.NOTE.get_value(self.UID, "asDict")

		if not self.PANEL : return

		if self.PATH :
			__treeiter0 = self.PANEL.TREESTORE.get_iter(self.PATH)
		else :
			__treeiter0 = None

		__treeiter1 = self.PANEL.toggle_finish(self.UID, __treeiter0, not was_finish)

		if __treeiter1 :
			self.PATH = self.PANEL.TREESTORE.get_path(__treeiter1)
		else :
			self.PATH = None

	def on_change_manner (self, widget) :
		if not self.NOTE.is_valid_uid(self.UID) : return

		if widget.get_active() == Conf.NOTE_MANNER_WIKI :
			__manner = "wiki"
		else :
			__manner = "plain"

		self.NOTE.set_value(self.UID, "manner", __manner)

		__content = self.TEXTBUFFER_RAW.get_text( \
			self.TEXTBUFFER_RAW.get_start_iter(), \
			self.TEXTBUFFER_RAW.get_end_iter(), \
			True \
		)

		self.NOTE.__export__()
		self.__insert_content_view(__content, __manner)

	############################################################
	def __store_label (self) :
		# remember the label info.
		__treeiter = self.xml.get_widget("combobox9").get_active_iter()
		__uid_label = self.TREESTORE_LABEL.get_value(__treeiter, 2)

		self.NOTE.set_value(self.UID, "label", __uid_label)
		self.NOTE.__export__()

		return __uid_label

	def __get_method_alarm (self) :
		if not self.xml.get_widget("checkbutton14").get_active() :
			return

		__radiobutton_dialog = self.xml.get_widget("radiobutton1")
		__radiobutton_osd = self.xml.get_widget("radiobutton2")

		if __radiobutton_dialog.get_active() :
			__method = "dialog"
		else :
			__method = "osd"

		return __method

	def __toggle_alarm_widget (self, activate=False) :
		__radiobutton_dialog = self.xml.get_widget("radiobutton1")
		__radiobutton_osd = self.xml.get_widget("radiobutton2")
		__comboboxentry = self.xml.get_widget("comboboxentry1")
		__combobox = self.xml.get_widget("combobox8")
		__expander = self.xml.get_widget("expander1")

		if activate :
			__expander.set_property("sensitive", True)
			__radiobutton_dialog.set_property("sensitive", True)
			__radiobutton_osd.set_property("sensitive", True)
			__comboboxentry.set_property("sensitive", True)
			__combobox.set_property("sensitive", True)
		else :
			__expander.set_property("sensitive", False)
			__radiobutton_dialog.set_property("sensitive", False)
			__radiobutton_osd.set_property("sensitive", False)
			__comboboxentry.set_property("sensitive", False)
			__combobox.set_property("sensitive", False)

	def __install_accel_group (self) :
		__keys_and_methods = { \
			"<Alt>1" : self.ac_view_content, \
			"<Alt>2" : self.ac_view_raw, \
			"<Alt>3" : self.ac_view_info, \
			"<Alt>4" : self.ac_view_alarm, \
			"<Alt>5" : self.ac_view_history, \
			"<Alt>s" : self.ac_toggle_finished, \
			"<Alt>t" : self.ac_focus_title, \
			"<Alt>r" : self.ac_remove, \
			"<Control>equal" : self.ac_zoom_default, \
			"<Control>plus" : self.ac_zoom_in, \
			"<Control>minus" : self.ac_zoom_out, \
		}

		__GROUP = gtk.AccelGroup()
		for keys, methods in __keys_and_methods.items() :
			__key, __mod = gtk.accelerator_parse(keys)
			if __key == 0 : continue
			__GROUP.connect_group( \
				__key, __mod, \
				gtk.ACCEL_VISIBLE, methods \
			)

		self.WIDGET_SELF.add_accel_group(__GROUP)

	def __parse_document (self, text, manner="wiki") :

		if self.PANEL and self.PANEL.IS_SEARCH_RESULT :
			__condition = self.STATE.get_value("search-condition")
			__string = self.STATE.get_value("search-string")
		else :
			__string = ""
			__condition = dict()

		if manner == "wiki" :
			__formatter = Formatter.Wiki(self.TITLE_QUOTED)
		else :
			__formatter = Formatter.Plain()

		st = __formatter.format(text, __string, **__condition)

		return st

	def refresh_content (self, content="", manner="") :

		if not manner.strip() :
			__combobox_manner = self.xml.get_widget("combobox10")
			if __combobox_manner.get_active() == Conf.NOTE_MANNER_WIKI :
				manner = "wiki"
			else :
				manner = "plain"

		if not content.strip() :
			content = self.TEXTBUFFER_RAW.get_text( \
				self.TEXTBUFFER_RAW.get_start_iter(), \
				self.TEXTBUFFER_RAW.get_end_iter(), \
				True \
			)

		self.__insert_content_view(content, manner)

	def __insertContent (self, htmlview, document, text, manner="wiki") :

		if text.strip() :
			st = self.__parse_document(text, manner)

			document.clear()
			document.open_stream("text/html")
			document.write_stream(st)
			document.close_stream()

			del(st)

			htmlview.zoom_reset()
			htmlview.zoom_in()
			htmlview.zoom_in()

			htmlview.jump_to_anchor("#top")

	def __insert_content_diff (self, text, manner="wiki") :
		self.__insertContent(self.HTMLVIEW_DIFF, self.DOCUMENT_DIFF, text, manner)

	def __insert_content_view (self, text, manner="wiki") :
		self.__insertContent(self.HTMLVIEW, self.DOCUMENT, text, manner)

	def __create_html_view (self) :

		__htmlview = gtkhtml2.View()
		__htmlview.set_border_width(0)
		__htmlview.show()

		__document = gtkhtml2.Document()

		__htmlview.set_document(__document)

		__document.connect("link_clicked", self.link_clicked)
		__document.connect("request_url", self.request_url)

		return (__htmlview, __document, )

	def request_url (self, document, url, stream) :
		(__protocol, __uri) = func.get_protocol_from_uri(url)

		# The size of html stream in gtkhtml2, must be > 2.
		st = " " * 3
		if __protocol in ["http", "https", "ftp", ] :
			#
			# NOT IMPLEMENTED
			#
			# Everytime when i using gtkhtml2 modules, the entire WEE did gonna be
			# freeeezed.
			#
			pass
		else :
			if os.path.exists(__uri) :
				__f = open(__uri, "r")
				st = "".join(__f.readlines())
				__f.close()

		stream.write(st)

	def link_clicked (self, document, link) :
		# if remote url,
		if sre.compile( \
				"^(rtsp|mms|http|https|ftp|mailto)").findall(link.strip().split(":")[0]) :
			gnome.url_show(link)
			return

		# if inner-page link,
		elif sre.compile( \
				"^#head-.*").findall(link) :
			#
			# NOT IMPLEMENTED
			#
			#print link
			return
		elif sre.compile("^download:*").findall(link) :
			__a = AttachmentCore.Core(self.TITLE_QUOTED)
			__filename = "".join(sre.compile("^download:").split(link.strip())[1:])
			if not __a.is_exist(__filename) :
				FileDialogAttachment( \
					self.TITLE_QUOTED, \
					__filename, \
					callback_functions={ \
						"refresh_content": self.refresh_content, \
					} \
				)
			else :
				FileDialogDownload( \
					self.TITLE_QUOTED, \
					__filename \
				)

		elif sre.compile("^attachment:*").findall(link) :

			FileDialogAttachment( \
				self.TITLE_QUOTED, \
				"".join(sre.compile("^attachment:").split(link.strip())[1:]), \
				callback_functions={ \
					"refresh_content": self.refresh_content, \
					"refresh_panel_attachment": self.PANEL_ATTACHMENT.insert_row, \
				} \
			)

			return

		return

		# if note link,
		__list_uid = self.NOTE.get_uid(link)
		if len(__list_uid) < 1 :
			__list_uid = [func.get_uid(), ]

		for i in __list_uid :
			Note(i, title=link, treeview=self.PANEL.WIDGET, state=self.STATE)

	def __set_label_finished (self) :
		if not self.DATA : return

		if self.GCONF_CLIENT.get_value_by_conf("show-shortcut") :
			__reentry_button = i18n.LABEL_SHORTCUT_NOTE["toolbutton25-reentry"]
			__finish_button = i18n.LABEL_SHORTCUT_NOTE["toolbutton25"]
		else :
			__reentry_button = i18n.LABEL_SHORTCUT_NOTE_NO["toolbutton25-reentry"]
			__finish_button = i18n.LABEL_SHORTCUT_NOTE_NO["toolbutton25"]

		if self.DATA["__timestamp_finished__"] > 0 :
			self.__toolbutton_label_finish.set_label(_(__reentry_button))
		else :
			self.__toolbutton_label_finish.set_label(_(__finish_button))

class Preferences (WIDGET.WIDGET) :

	GCONF_CLIENT = None
	STATE = None
	LABEL = None
	NOTE = None

	TREESTORE_LABEL = None
	COMBOBOX_LABEL = None
	__NOW_INSERTING_LABEL = False

	def __init__ (self, **kwargs) :

		if kwargs.has_key("view") :
			__view = kwargs["view"]
		else :
			__view = Conf.PREFERENCES_NOTEBOOK_TAB_MAIN

		if kwargs.has_key("treestore_label") :
			self.TREESTORE_LABEL = kwargs["treestore_label"]

		if kwargs.has_key("combobox_label") :
			self.COMBOBOX_LABEL = kwargs["combobox_label"]

		if not kwargs.has_key("state") :
			raise ValueError, _("state must be included.")
		else :
			self.STATE = kwargs["state"]
			self.NOTE = self.STATE.get_value("note")
			self.LABEL = self.STATE.get_value("label")

		WIDGET.WIDGET.__init__(self, "preferences", \
			None, dict(), Handler.PREFERENCES)

		for i, j in i18n.LABEL_PREFERENCES.items() :
			self.xml.get_widget(i).set_label(_(j))

		self.GCONF_CLIENT = GConf.Client()
		self.GCONF_CLIENT.set_path(Conf.LOCAL_ROOT)
		self.GCONF_CLIENT.add_dir(Conf.LOCAL_ROOT)

		# apply settings.
		__combobox_manner = self.xml.get_widget("combobox6")
		__combobox_manner.insert_text(0, _("Wiki"))
		__combobox_manner.insert_text(1, _("Plain"))

		__manner = self.GCONF_CLIENT.get_value_by_conf("note-manner")
		if __manner == "wiki" :
			__combobox_manner.set_active(Conf.NOTE_MANNER_WIKI)
		else :
			__combobox_manner.set_active(Conf.NOTE_MANNER_PLAIN)

		__checkbutton_show_shortcut = self.xml.get_widget("checkbutton13")
		if self.GCONF_CLIENT.get_value_by_conf("show-shortcut") :
			__checkbutton_show_shortcut.set_active(True)
		else :
			__checkbutton_show_shortcut.set_active(False)

		__combobox_time_format = self.xml.get_widget("combobox7")
		__combobox_time_format.insert_text( \
			Conf.NOTE_TIME_FORMAT_FRIENDLY, \
				func.get_formatted_time(time.time(), "Today %p %l:%M"))
		__combobox_time_format.insert_text( \
			Conf.NOTE_TIME_FORMAT_FULLY, \
				func.get_formatted_time(time.time(), "%Y-%m-%d %H:%M"))
		__combobox_time_format.insert_text( \
			Conf.NOTE_TIME_FORMAT_DIGIT, \
				func.get_formatted_time(time.time(), "%c"))

		__time_format = self.GCONF_CLIENT.get_value_by_conf("note-time-format")
		if __time_format == "Today %p %l:%M" :
			__combobox_time_format.set_active(Conf.NOTE_TIME_FORMAT_FRIENDLY)
		elif __time_format == "%Y-%m-%d %H:%M" :
			__combobox_time_format.set_active(Conf.NOTE_TIME_FORMAT_FULLY)
		elif __time_format == "%c" :
			__combobox_time_format.set_active(Conf.NOTE_TIME_FORMAT_DIGIT)
		else :
			__combobox_time_format.set_active(Conf.NOTE_TIME_FORMAT_FRIENDLY)

		self.__NOW_INSERTING_LABEL = True
		import Panel
		self.PANEL = Panel.Label( \
			self.xml, \
			state=self.STATE \
		)
		self.__NOW_INSERTING_LABEL = False

		self.PANEL.TREESTORE.connect("row-changed", self.on_change_row_changed)
		self.PANEL.WIDGET.connect("columns-changed", self.on_change_row_changed)

		self.xml.get_widget("notebook4").set_current_page(__view)

	##################################################
	# HANDLER
	def on_change_column_changed (self, widget, parm0=None, parm1=None) :
		self.update_notelist_for_label()

		if not self.__NOW_INSERTING_LABEL :
			self.__update_combobox_label_in_notelist()

	def on_change_row_changed (self, widget, parm0=None, parm1=None) :
		if self.TREESTORE_LABEL : self.__refresh_combobox_label()

		self.update_notelist_for_label()

		if not self.__NOW_INSERTING_LABEL :
			self.__update_combobox_label_in_notelist()

	def update_notelist_for_label (self) :
		__treeview_of_notelist = self.STATE.get_value("treeview-notelist")

		if not __treeview_of_notelist : return

		__treestore = __treeview_of_notelist.get_model()
		__treestore.foreach(self.__update_notelist_for_label)

	def __update_combobox_label_in_notelist (self) :
		# update the combobox for label in note list
		if not self.STATE.get_value("panel-notelist") : return

		__combobox = self.STATE.get_value("combobox-label-notelist")
		__treestore_label = __combobox.get_model()
		if not __treestore_label : return

		__uid_current = \
			__treestore_label.get_value(__combobox.get_active_iter(), 2)

		__treestore_label.clear()

		__pixbuf = func.get_pixbuf_filled_with_color( \
			None, Conf.COMBOBOX_LABEL_SIZE)
		__treestore_label.append( \
			None, [__pixbuf , _("View All"), "__view_all__", ])

		__idx = 0
		__idx_current = None
		__idx_default = Conf.COMBOBOX_SELECT_LABEL_ALL
		for i in self.LABEL.ITEM_LIST.keys() :

			__data = self.LABEL.get_value(i, "asDict")
			if not __data : continue

			if i == __uid_current : __idx_current = __idx

			if __data["is_default"] :
				__idx_default = __idx
				__name = "%s (%s)" % (__data["name"], _("Default"), )
			else :
				__name = __data["name"]

			__pixbuf = func.get_pixbuf_filled_with_color( \
				__data["color"], Conf.COMBOBOX_LABEL_SIZE)
			__treestore_label.append(None, [__pixbuf , __name, i, ])

			__idx += 1

		if __uid_current == "__view_all__" :
			__idx_current = 0
		elif not __idx_current :
			__idx_current = __idx_default

		__combobox.set_active(__idx_current)

	def __update_notelist_for_label (self, model, path, iter) :
		__uid = model.get_value(iter, Conf.TREEVIEW_NOTE_PANEL_COLUMN_UID)
		__text = model.get_value(iter, Conf.TREEVIEW_NOTE_PANEL_COLUMN_TEXT)

		if not __uid : return

		__label = self.NOTE.get_value(__uid, "asDict")["label"]
		try :
			__color = self.LABEL.get_value(__label, "asDict")["color"]
		except TypeError :
			return

		__pixbuf = func.get_pixbuf_filled_with_color( \
			__color, Conf.NOTE_LABEL_SIZE)
		model.set_value(iter, Conf.TREEVIEW_NOTE_PANEL_COLUMN_COLOR, __pixbuf)

	def on_set_default (self, widget) :
		__treestore, __treeiter = \
			self.PANEL.WIDGET.get_selection().get_selected()

		if not __treeiter : return

		__uid = __treestore.get_value( \
			__treeiter, Conf.TREEVIEW_LABEL_PANEL_COLUMN_UID)

		# check is already default?
		if self.LABEL.get_value(__uid, "asDict")["is_default"] : return

		self.LABEL.set_default(__uid)
		self.__refresh_panel_label()

		self.LABEL.__export__()

		if self.TREESTORE_LABEL : self.__refresh_combobox_label()

	def __refresh_panel_label (self) :
		self.PANEL.TREESTORE.clear()

		# reset the combobox entries.
		for i in self.LABEL.ITEM_LIST.keys() :
			__data = self.LABEL.get_value(i, "asDict")
			if not __data : continue

			if __data["is_default"] :
				__name = "%s (%s)" % (__data["name"], _("Default"), )
			else :
				__name = __data["name"]

			__pixbuf = func.get_pixbuf_filled_with_color( \
				__data["color"], Conf.PREFERENCES_LABEL_SIZE)
			self.PANEL.TREESTORE.append(None, [__pixbuf , __name, i, ])

	def __refresh_combobox_label (self) :
		self.TREESTORE_LABEL.clear()

		# reset the combobox entries.
		__combobox0_index = 0
		__combobox0_index_default = __combobox0_index
		for i in self.LABEL.ITEM_LIST.keys() :
			__data = self.LABEL.get_value(i, "asDict")
			if not __data : continue

			if __data["is_default"] :
				__name = "%s (%s)" % (__data["name"], _("Default"), )
				__combobox0_index_default = __combobox0_index
			else :
				__name = __data["name"]

			__pixbuf = func.get_pixbuf_filled_with_color( \
				__data["color"], Conf.COMBOBOX_LABEL_SIZE)
			self.TREESTORE_LABEL.append(None, [__pixbuf , __name, i, ])

			__combobox0_index += 1

		self.COMBOBOX_LABEL.set_active(__combobox0_index_default)

	def on_remove_label (self, widget) :
		__treestore, __treeiter = \
			self.PANEL.WIDGET.get_selection().get_selected()

		if not __treeiter : return

		__uid = __treestore.get_value( \
			__treeiter, Conf.TREEVIEW_LABEL_PANEL_COLUMN_UID)
		__treestore.remove(__treeiter)

		self.LABEL.remove(__uid)
		self.LABEL.__export__()

		if not self.__NOW_INSERTING_LABEL :
			self.__update_combobox_label_in_notelist()

	def on_edit_label (self, widget, path=None, view_column=None, user_param1=None) :
		__treestore, __treeiter = \
			self.PANEL.WIDGET.get_selection().get_selected()

		if not __treeiter : return

		EditLabel(action="edit", treeview=self.PANEL.WIDGET, state=self.STATE)

	def on_add_label (self, widget) :
		EditLabel(action="add", treeview=self.PANEL.WIDGET, state=self.STATE)

	def on_change_time_format (self, widget) :
		__selected = widget.get_active()
		if __selected == Conf.NOTE_TIME_FORMAT_FRIENDLY :
			self.GCONF_CLIENT.set_value_by_conf( \
				"note-time-format", "Today %p %l:%M")
		elif __selected == Conf.NOTE_TIME_FORMAT_FULLY :
			self.GCONF_CLIENT.set_value_by_conf( \
				"note-time-format", "%Y-%m-%d %H:%M")
		elif __selected == Conf.NOTE_TIME_FORMAT_DIGIT :
			self.GCONF_CLIENT.set_value_by_conf( \
				"note-time-format", "%c")
		else :
			return

	def on_change_manner (self, widget) :
		__selected = widget.get_active()
		if __selected == Conf.NOTE_MANNER_WIKI :
			self.GCONF_CLIENT.set_value_by_conf("note-manner", "wiki")
		elif __selected == Conf.NOTE_MANNER_PLAIN :
			self.GCONF_CLIENT.set_value_by_conf("note-manner", "plain")
		else :
			return

	def on_toggle_shortcut (self, widget) :
		self.GCONF_CLIENT.set_value_by_conf( \
			"show-shortcut", widget.get_active())


class FileDialogDownload (WIDGET.WIDGET) :

	FILENAME = str()
	TITLE = str()

	def __init__ (self, PAGENAME, filename) :
		self.FILENAME = filename
		self.ATTACHMENT = AttachmentCore.Core(PAGENAME)

		WIDGET.WIDGET.__init__( \
			self, "filechooserdialog_attachment", None, dict(), \
				Handler.FILEDIALOG_ATTACHMENT)

		self.WIDGET_SELF.set_title(_("Open File"))
		self.WIDGET_SELF.set_property("action", gtk.FILE_CHOOSER_ACTION_SAVE)

		self.WIDGET_SELF.set_current_name(filename)

	def on_open (self, widget) :
		__filename = self.WIDGET_SELF.get_filename()

		if not __filename.strip() : return
		if not self.__save(__filename) : return

		self.on_close(widget)

	def __save (self, filename) :

		try :
			shutil.copy(self.ATTACHMENT.get_full_path(self.FILENAME), filename)
		except IOError :
			return False

		return True

class FileDialogAttachment (WIDGET.WIDGET) :

	FILENAME = str()
	TITLE = str()
	ATTACHMENT = None

	PANEL = None
	CALLBACK_FUNCTIONS = dict()

	def __init__ (self, PAGENAME, target_filepath="", **kwargs) :
		self.ATTACHMENT = AttachmentCore.Core(PAGENAME)
		self.FILENAME = target_filepath

		if kwargs.has_key("panel") :
			self.PANEL = kwargs["panel"]

		if kwargs.has_key("callback_functions") :
			self.CALLBACK_FUNCTIONS = kwargs["callback_functions"]

		WIDGET.WIDGET.__init__( \
			self, "filechooserdialog_attachment", None, dict(), \
				Handler.FILEDIALOG_ATTACHMENT)

		self.WIDGET_SELF.set_title(_("Select File"))

	def on_open (self, widget) :
		__filename = self.WIDGET_SELF.get_filename()

		if not __filename.strip() : return

		if not self.FILENAME :
			self.FILENAME = os.path.basename(__filename)

		if not self.ATTACHMENT.save(__filename, self.FILENAME) : return

		if self.PANEL :
			self.PANEL.add_row( \
				self.FILENAME,
				self.ATTACHMENT.get_info(self.FILENAME) \
			)

		if self.CALLBACK_FUNCTIONS.has_key("refresh_content") :
			self.CALLBACK_FUNCTIONS["refresh_content"]()

		if self.CALLBACK_FUNCTIONS.has_key("refresh_panel_attachment") :
			self.CALLBACK_FUNCTIONS["refresh_panel_attachment"]()

		self.on_close(widget)

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "Window.py"


