# -*- coding: utf-8 -*-
#    Copyright (C) 2005 Spike^ekipS <spikeekips@gmail.com>
#
#    http://vee.kldp.net
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import os, gettext as __gettext
import Conf__

def gettext () :
	try :
		t = __gettext.translation("wee", Conf__.DIR_LOCALE)
	except IOError :
		return __gettext.gettext
	else :
		return t.ugettext

def getDirectoryLocale (localedir) :
	# get locale environment value.

	envvars = ("LC_ALL", "LANG", "LC_MESSAGES", )

	for i in envvars :
		__v = os.getenv(i)

		if __v :
			envLocale = __v
			break

	langlist = __gettext._expand_lang(envLocale)
	for lang in langlist :
		if lang == "C" : return None

		__dir = os.path.join(localedir, lang)
		if os.path.exists(__dir) and os.path.isdir(__dir) :
			return __dir

	return None

####################################################################33
# label name
_ = gettext()
LABEL_NOTELIST = { \
	"label312" : "Filter", \
	"label314" : "View", \
	"checkbutton21" : "View finished?", \
	"label317" : "Contains the Text", \
	"label321" : "More options,", \
	"label319" : "Which?", \
	"checkbutton22" : "case insensitive?", \
	"checkbutton23" : "exact match?", \
	"checkbutton24" : "use \"Regular Expression\"", \
	"label322" : "Find", \
	"label323" : "Back", \
}

LABEL_NOTE = { \
	"label256" : "Wiki Name", \
	"label252" : "Modified Time", \
	"label251" : "Created Time", \
	"label259" : "Finished Time", \
	"label270" : "Time to alarm", \
	"checkbutton14" : "Set alarm?", \
	"label274" : "How much to wait?", \
	"label273" : "<b>Method</b>", \
	"label279" : "More details,", \
	"label290" : "<b>Etc</b>", \
	"label291" : "Editing manner", \
	"radiobutton1" : "Dialog", \
	"radiobutton2" : "OSD", \
	"label327" : "<b>General Information</b>", \
	"label324" : "<b>Attached Files</b>", \
	"label329" : "Open", \
	"label326" : "Remove", \
	"label328" : "Save", \
	"label270" : "<b>Time to alarm</b>", \
	"label333" : "<span size=\"large\">You can use Drag &amp; Drop in <span weight=\"bold\">Attached Files</span> panel.</span>", \
	"label334" : "<span size=\"small\">In example, you drag the file in nautilus, and drop it in <span weight=\"bold\">Attached Files</span> panel, and it will be added as attachment.</span>", \
	"label339" : "Difference", \
	"label342" : "View Content", \
	"label336" : "<b>History List</b>", \
}

LABEL_SHORTCUT_NOTE_NO = { \
	"label232" : "<b>Title</b>", \
	"label234" : "<b>Content</b>", \
	"label235" : "<b>Raw</b>", \
	"label244" : "<b>Info</b>", \
	"label269" : "<b>Setting</b>", \
	"label335" : "<b>History</b>", \

	"toolbutton24" :				"Close", \
	"toolbutton25" :				"Finish", \
	"toolbutton25-reentry" :	"Re-Entry", \
	"toolbutton26" :				"Remove", \
}

LABEL_SHORTCUT_NOTE = { \
	"label232" : "<b>Title</b>\n<span size=\"x-small\">Alt+T</span>", \
	"label234" : "<b>Content</b>\n<span size=\"x-small\">Alt+1</span>", \
	"label235" : "<b>Raw</b>\n<span size=\"x-small\">Alt+2</span>", \
	"label244" : "<b>Info</b>\n<span size=\"x-small\">Alt+3</span>", \
	"label269" : "<b>Setting</b>\n<span size=\"x-small\">Alt+4</span>", \
	"label269" : "<b>Setting</b>\n<span size=\"x-small\">Alt+4</span>", \
	"label335" : "<b>History</b>\n<span size=\"x-small\">Alt+5</span>", \

	"toolbutton24" :				"Close\n<span size=\"x-small\">Alt+C / Escape</span>", \
	"toolbutton25" :				"Finish\n<span size=\"x-small\">Alt+S</span>", \
	"toolbutton25-reentry" :	"Re-Entry\n<span size=\"x-small\">Alt+S</span>", \
	"toolbutton26" :				"Remove\n<span size=\"x-small\">Alt+R</span>", \
}

LABEL_ALARM_DIALOG = { \
	"label277" : "<span size=\"small\">This is Alarm message.</span>", \
}

LABEL_MENU_NOTE = { \
	"edit3" : "Edit", \
	"remove2" : "Remove", \
	"finish_it1" : "Finish It", \
	"re-entry1" : "Re-Entry", \
	"preferences2" : "Prefernces", \
}

LABEL_MAIN_MENU = { \
	"file1" : "_File", \
	"new_note" : "_Add New", \
	"close" : "_Close", \
	"edit2" : "_Edit", \
	"preferences1" : "_Preferences", \
	"contents1" : "_Contents", \
	"help1" : "_Help", \
	"about1" : "_About", \
}

LABEL_PREFERENCES = { \
	"label51" : " Main ", \
	"label263" : " ETC ", \
	"label282" : " Label ", \
	"label50" : "<b>General</b>", \
	"label262" : "<b>Editing</b>", \
	"label241" : "Which editing manner do you use as default?", \
	"label266" : "<b>Time Format</b>", \
	"label268" : "Show like this", \
	"checkbutton13" : "Show keyboard shortcut?", \
}

DIALOG_ERROR_ENTER_TEXT = { \
	"label242" : \
"""<span size="larger">Enter the "Title" text.</span>
<span size="small">If you did not, any text will not be saved.</span>

Close anyway?""", \

}

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "i18n.py"


